var prefBranch = null;
var ACTIVE_BUTTON_PREF = "extensions.alexa.active-buttons";

function Init()
{
  prefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

  var active_buttons  = prefBranch.getCharPref("extensions.alexa.active-buttons").split(",");
  var toolbar = document.getElementById("ALX_NS_PH_TB-Toolbar");
  var labels = {};
  for (var i = 0; i < active_buttons.length; i++)
  {
    var key = active_buttons[i];
    if (key && key.length)
    {
      var xml = prefBranch.getCharPref("extensions.alexa.active-buttons." + key);
      var parser = new DOMParser();
      var doc = parser.parseFromString(xml, "text/xml");
      var titles = doc.documentElement.getElementsByTagName("title");
      if (titles && titles.length)
      {
        labels[key] = titles.item(0).textContent
      }
    }
  }


  // Fill active_buttons listbox
  var active_buttons_listbox = document.getElementById('active_buttons');
  for (var i = 0; i < active_buttons.length; i++) {
    var key = active_buttons[i];
    var label = labels[key];
    if (key && label)
    {
      AddListItem(document, active_buttons_listbox, key, label);
    }
  }
}

function enable_save()
{
  var save_button = document.documentElement.getButton("accept");
  save_button.removeAttribute('disabled');
}

function update_buttons()
{
  var active_buttons = document.getElementById('active_buttons');
  var remove_button = document.getElementById('remove_button');
  var add_button = document.getElementById('add_button');
  var up_button = document.getElementById('up_button');
  var down_button = document.getElementById('down_button');

  var activeButtonSelected = (active_buttons.selectedItems.length > 0);
  remove_button.disabled = !activeButtonSelected;

  if (activeButtonSelected)
  {
    up_button.disabled = !(active_buttons.selectedItems[0].previousSibling);
    down_button.disabled = !(active_buttons.selectedItems[0].nextSibling);
  }
  else
  {
    up_button.disabled = true;
    down_button.disabled = true;
  }
}

function RemoveActiveButton()
{
  var listbox = document.getElementById('active_buttons');
  var nextNode = null;
  var numSelected = listbox.selectedItems.length;

  var numSelectedItems = listbox.selectedItems.length;
  for (var count = 0; count < numSelectedItems; count++)
  {
    var item = listbox.selectedItems[0];
    var key = item.id;
    var label = item.label;
    listbox.removeChild(item);
  }

  listbox.clearSelection();

  enable_save();
}



function Save()
{
  var active_button_listbox = document.getElementById('active_buttons');
  var active_buttons = [];

  for (var item = active_button_listbox.firstChild; item != null; item = item.nextSibling)
  {
    var buttonid = item.id;
    if (buttonid.length > 1)
    {
      active_buttons.push(buttonid);
    }
  }

  try
  {
    prefBranch.setCharPref(ACTIVE_BUTTON_PREF, active_buttons.join(","));
    window.close();
  }
  catch(ex)
  {
    confirm('exception' + ex);
  }
  return true;
}


function MoveUp()
{
  var listbox = document.getElementById('active_buttons');
  if (listbox.selectedItems.length == 1)
  {
    var selected = listbox.selectedItems[0];
    var before = selected.previousSibling
    if (before)
    {
      listbox.insertBefore(selected, before);
      listbox.selectItem(selected);
      listbox.ensureElementIsVisible(selected);
    }
  }

  enable_save();
}


function MoveDown()
{
  var listbox = document.getElementById('active_buttons');
  if (listbox.selectedItems.length == 1)
  {
    var selected = listbox.selectedItems[0];
    if (selected.nextSibling)
    {
      if (selected.nextSibling.nextSibling)
        listbox.insertBefore(selected, selected.nextSibling.nextSibling);
      else
        selected.parentNode.appendChild(selected);
      listbox.selectItem(selected);
    }
  }

  enable_save();
}

function AddListItem(doc, listbox, ID, UIstring)
{
  var item = doc.createElement('listitem');

  item.setAttribute('label', UIstring);
  item.setAttribute('id', ID);

  listbox.appendChild(item);
}
