
(function ( )  {
  if( typeof ALX_NS_PH == 'undefined' ) {
    window.ALX_NS_PH = { };
  }
  function log( msg ) {
    dump( 'ALX_NS_PH.CBA: ' +  msg + "\n" );
  }
  function props( msg ) {
    var msg = [ ];
    for( i in msg ) {
      msg.append( i );
    }
    log( msg + ': ' + msg.join( '\n' ) );
  }
  function resolver( name ) {
    return ({
      'alexa' : "http://rdf.alexa.com/terms/",
      'rdf'   : "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
      'xlink' : "http://www.w3.org/1999/xlink",
    })[ name ];
  }
  function makeURL( input ) {
    var URL = Components.classes["@mozilla.org/network/standard-url;1"]
                        .getService( Components.interfaces.nsIURL );
    URL.spec = input;
    return URL;
    //return URL.
  }
  if( typeof ALX_NS_PH.Prefs == 'undefined' ) {
    ALX_NS_PH.Prefs = { 'root': Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService)
                  };
    ALX_NS_PH.Prefs.branches = { 'alexa' : ALX_NS_PH.Prefs.root
                                            .getBranch("extensions.alexa."),
                             'gp'    : ALX_NS_PH.Prefs.root
                                            .getBranch("extensions.googlepreview."),
                           };

  }

  function getCBAImageURI( original, hint ) {
    var uri = ALX_NS_PH.Prefs.branches.alexa.getCharPref( 'uri.CBA' );
    var prepath = uri.split( '?' )[ 0 ];
    var query   = uri.split( '?' )[ 1 ]
    return prepath
        +  encodeURIComponent( original )
        + '?hint=' + encodeURIComponent( hint )
        + '&'      + query;
    
  }

  if( typeof ALX_NS_PH.ReBrandedLinks == 'undefined' ) {
    ALX_NS_PH.ReBrandedLinks = {
      'onload': function ( evt ) {
        log( 'running CBA Rebranding Efforts. ' 
           + ALX_NS_PH.Prefs.branches.alexa.getBoolPref( 'searchranks' ) 
           ?  "yes":"no" );
        
        if( !ALX_NS_PH.Prefs.branches.alexa.getBoolPref( 'searchranks' ) )
          return true;

        var T = null;
        var Layout = null;
        var length = null;
        var S = null;
        for( T in ALX_NS_PH.CBALayouts ) {
          Layout = ALX_NS_PH.CBALayouts[ T ];
          if( Layout.hit( evt.target ) ) {
            log( "HIT:" + T );
            length = Layout.strategies.length;
            for(var x=0; x<length; x++ ) {
              log( "Strategy: " + x + '/' + length );
              S = Layout.strategies[ x ];
              S( evt.target, Layout.onsuccess, Layout.onfailure );
            }
          } else {
            log( "MISS:" + T );
          }
        }
      },
    };
  }
  if( typeof ALX_NS_PH.CBALayouts == 'undefined' ) {
    ALX_NS_PH.CBALayouts = {
      'google': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/www(|[0-9])\.(|l\.)google\..*\//i);
           return result != null;
        },
        'strategies': [
          function( doc, onsuccess, onfailure ) {
            // Sidebar Ads
            /*
              table id=mbEnd
                td=rhsline
                  ol
                    li
                      h3 a
                      cite
            */
            function nextSiblingElement( node ) {
              var next = null;
              for( next = node.nextSibling; next && next.nodeType == 3; next = next.nextSibling ) { }
              return next;
            }
            function findInsertion ( cite ) {
              for( var next = nextSiblingElement( cite );
                   next && next.tagName != 'A' && next.nextSibling;
                   next = nextSiblingElement( next ) ) { }
              return next && next.tagName == 'A' ? next.nextSibling : null;
            }
            var rhsline = doc.getElementById( 'rhsline' );
            var list = null;
            if( rhsline ) {
              list = rhsline.getElementsByTagName( 'OL' )[ 0 ];
              var items = list.getElementsByTagName( 'LI' );
              var length = items.length;
              var item   = null;
              var hint   = null;
              var target = null;
              var image  = null;
              var anchor = null;
              var cite   = null;
              for( var x=0; x<length; x++ ) {
                item   = items[ x ];
                target = item.getElementsByTagName( 'H3' )[ 0 ]
                             .getElementsByTagName( 'A'  )[ 0 ]
                             .href;

                cite   = item.getElementsByTagName( 'CITE' )[ 0 ];
                hint   = cite.textContent;

                anchor      = doc.createElement( 'A' );
                anchor.href = target;
                anchor.style.display = "block";

                image  = new window.content.Image( );

                image.addEventListener( 'error', onfailure, false );
                image.addEventListener( 'load',  onsuccess, false );
                //item.appendChild( anchor );
                var insert = findInsertion( cite );
                if (insert)
                {
                  insert.parentNode.insertBefore( document.createTextNode(" "), insert );
                  insert.parentNode.insertBefore( anchor, insert );
                }
                else
                {
                  cite.parentNode.appendChild( document.createTextNode(" ") );
                  cite.parentNode.appendChild( anchor );
                }
                image.style.border = 'none ';
                image.src = getCBAImageURI( target, hint );

                if (image.src)
                {
                  var converter = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter);
                  converter.charset = "UTF-8";
                  var md5 = Cc["@mozilla.org/security/hash;1"].createInstance(Ci.nsICryptoHash);
                  var data = null;
                  var result = {};
                  
                  md5.init(md5.MD5);
                  data = converter.convertToByteArray(image.src, result);
                  md5.update(data, data.length);
                  var id = md5.finish(true);
                  image.id = id;
                  
                  var check = doc.getElementById( id );
                  if (check == null)
                    anchor.appendChild( image );
                }
              }
            }
          },
          function( doc, onsuccess, onfailure ) {
            // Top Ads
            /*
              div id=tads
                ol
                  li
                    h3 a
                    cite
            */
            function findInsertion ( cite ) {
              for( var next=cite.nextSibling;
                   next.tagName != 'BR' && next.nextSibling;
                   next = next.nextSibling ) { }
              return next && next.tagName == 'BR' ? next : null;
            }
            var tads = doc.getElementById( 'tads' );
            var list = null;
            if( tads ) {
              list = tads.getElementsByTagName( 'OL' )[ 0 ];
              var items = list.getElementsByTagName( 'LI' );
              var length = items.length;
              var item   = null;
              var hint   = null;
              var target = null;
              var image  = null;
              var anchor = null;
              var cite   = null;
              for( var x=0; x<length; x++ ) {
                item   = items[ x ];
                target = item.getElementsByTagName( 'H3' )[ 0 ]
                             .getElementsByTagName( 'A'  )[ 0 ]
                             .href;

                cite   = item.getElementsByTagName( 'CITE' )[ 0 ];
                hint   = cite.textContent;


                anchor      = doc.createElement( 'A' );
                anchor.href = target;

                image  = new Image( );
                image.addEventListener( 'error', onfailure, false );
                image.addEventListener( 'load',  onsuccess, false );
                //item.appendChild( anchor );
                var insert = findInsertion( cite );
                if (insert)
                {
                  insert.parentNode.insertBefore( document.createTextNode(" "), insert );
                  insert.parentNode.insertBefore( anchor, insert );
                }
                else
                {
                  cite.parentNode.appendChild( document.createTextNode(" ") );
                  cite.parentNode.appendChild( anchor );
                }
                image.style.border = 'none ';
                image.style.verticalAlign = 'bottom';
                image.src = getCBAImageURI( target, hint );

                if (image.src)
                {
                  var converter = Cc["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Ci.nsIScriptableUnicodeConverter);
                  converter.charset = "UTF-8";
                  var md5 = Cc["@mozilla.org/security/hash;1"].createInstance(Ci.nsICryptoHash);
                  var data = null;
                  var result = {};
                  
                  md5.init(md5.MD5);
                  data = converter.convertToByteArray(image.src, result);
                  md5.update(data, data.length);
                  var id = md5.finish(true);
                  image.id = id;
                  
                  var check = doc.getElementById( id );
                  if (check == null)
                    anchor.appendChild( image );
                }
              }
            }
          },
        ],
        'onsuccess': function( event ) {
          log( 'SUCCESS: ' + event.target.src );

        },
        'onfailure': function( event ) {
          log( 'FAILURE: ' + event.target.src );
          var target = event.target;
          target.parentNode.parentNode.removeChild( target.parentNode );

        },
      },
    };
  }
})( );

