(function() {
     var _VERSION_TOOLBAR_ROOT_PLACEHOLDER_=location.href.substr(0,location.href.lastIndexOf("/")+1);
     var _XTRA_="";

   if (typeof Alexa == 'undefined') {
        window.Alexa = {
            'executeScript': function(doc, url, xml, xtraVars) {
		if(typeof xtraVars !=  'undefined'){
		    _XTRA_=xtraVars + "&";
		}
                Alexa.Results.onload(doc, url, xml);
            }
        };
    }
    function props(msg) {
        var msg = [];
        for (i in msg) {
            msg.append(i);
        }
    }
    function resolver(name) {
        return ({
            'alexa': "http://rdf.alexa.com/terms/",
            'rdf': "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
            'xlink': "http://www.w3.org/1999/xlink"
        })[name];
    }
    function createXmlObject()
    {
      var aVersions=["MSXML2.DOMDocument.5.0",
                      "MSXML2.DOMDocument.4.0",
                      "MSXML2.DOMDocument.3.0",
                      "MSXML2.DOMDocument",
                      "Microsoft.xmlDom"];
      for(var i=0;i<aVersions.length;i++){
        try{
          var oXMLDom=new ActiveXObject(aVersions[i]);
          return oXMLDom;
        }
        catch(oError){
          
        }
      }
    }
    if (typeof Alexa.Results == 'undefined') {
        Alexa.Results = {
            'rank2code': function( rank ) {
              rank = +rank;
              return rank ==      0 ? 'x'
                   : rank <=    100 ? 'f'
                   : rank <=    180 ? 'e'
                   : rank <=    320 ? 'd'
                   : rank <=    560 ? 'c'
                   : rank <=   1000 ? 'b'
                   : rank <=   1800 ? 'a'
                   : rank <=   3200 ? '9'
                   : rank <=   5600 ? '8'
                   : rank <=  10000 ? '7'
                   : rank <=  18000 ? '6'
                   : rank <=  32000 ? '5'
                   : rank <=  56000 ? '4'
                   : rank <= 100000 ? '3'
                   : rank <= 180000 ? '2'
                   : rank <= 320000 ? '1'
                   :                  '0'
                   ;


            },
            'sendResult': function(doc, results, url, http)
            {
              var current = null;
              var uris = [];
              for (var x = 0; x < results.length; x++) {
                  current = results[x];
                  uris.push(current.href);
              }
              if (uris.length == 0)
                  return true;

              var uri = 'http://widgets.alexa.com/traffic/rankr/?ref=' + url;
              http.open('POST', uri, true, '', '');
              http.setRequestHeader('accept', 'application/xml');
              http.onreadystatechange = function() {
                  if (http.readyState == 4 && http.status == 200) {
                      var current = null;
                      var cursor = null;
                      var rank = null;
                      var site = null;
                      var info = null;
                      for (var x = 0; x < results.length; x++) {
                          current = results[x];
                          var retVal = Alexa.Results.getRank(current.href, http.responseText);
                          rank = retVal["rank"];
                          site = (retVal["site"] != null) ? retVal["site"] : current.href;
                          current.rank = rank;
                          current.addRank(doc, rank, site);
                      }

                  }
              };
              http.send(uris.join("\n"));
            },
            'getRank': function(href, text) {
                var xml = createXmlObject(); 
                var retVal = {rank: 0, site: null};
                xml.loadXML(text);
                xml.setProperty("SelectionLanguage", "XPath");
                xml.setProperty("SelectionNamespaces", "xmlns:rdf='http://www.w3.org/1999/02/22-rdf-syntax-ns#' xmlns:xlink='http://www.w3.org/1999/xlink' xmlns:alexa='http://rdf.alexa.com/terms/'");

                try {
                  var cursor = xml.selectSingleNode(
                                        "//alexa:site[ @rdf:about ="
                                      + "//alexa:page[ @rdf:about = '"
                                      + href          + "' ]"
                                      + "/alexa:site/@rdf:resource ]"
                                );

                  retVal["rank"] = cursor.getAttribute('alexa:rank');
                  retVal["site"] = cursor.getAttribute('rdf:about');
                } catch( e ) {
                  retVal["rank"] = 0; 
                }
                return retVal;
            },
            'onload': function(doc, url, http) {
                var results = Alexa.Targets.findTarget(doc, url, http);
                Alexa.Results.sendResult( doc, results, url, http )
            },
            'Result': function(doc, href, insertion) {
                this.href = href;
                var anchor = doc.createElement('A');
                this.insertion = insertion;
                return this;
            }

        };
        Alexa.Results.Result.prototype = {
            'rank': null,
            'href': null,
            'insertion': null,
            'addRank': function(doc, rank, url) {
		var _toolbar_base_ = "__VERSION__TOOLBAR__ROOT__PLACEHOLDER__";
		if(_VERSION_TOOLBAR_ROOT_PLACEHOLDER_.length>0){
		    _toolbar_base_ = _VERSION_TOOLBAR_ROOT_PLACEHOLDER_;
		}
                var anchor = doc.createElement('A');
                var label    = 'Alexa Traffic Rank for ' 
                               + url + ': ' 
                               + ( rank > 0 
                                 ? rank.toLocaleString( )
                                 : 'unavailable' )
                               ;
                //window.alert(url);
                var target   = url.split( '://' );
                if (target.length > 1) {
		    target.shift( );
		}
                target       = target.join( '' ).split( '?' );
                target       = target.length > 1 
                             ? target[ 0 ] + encodeURIComponent( '?' + target[ 1 ] )
                             : target.join( '?' )
                             ;
                anchor.href = 'http://www.alexa.com/data/details/traffic_details/' + target;
                anchor.style.paddingRight = "1ex";
                anchor.style.textDecoration = 'none';
                anchor.title = label
                //anchor.innerText = "Site Rank: " + rank;
                var img      = doc.createElement('IMG');
                img.style.border = 'none';
                img.alt      = label;
                img.title    = label;
                img.src      = _toolbar_base_ + "rank/" +  
                               Alexa.Results.rank2code( rank ) + ".png" ;
                anchor.appendChild( img );

                if (this.insertion) {
                    try {
                      // Avoid a double insertion
                      if (this.insertion.firstChild != null &&
                        this.insertion.firstChild.tagName == "A" &&
                        this.insertion.firstChild.href.indexOf(anchor.href) == 0) {
                        return;
                      }
                      this.insertion.insertBefore(anchor, this.insertion.firstChild);
                    } catch ( e ) {
                        return;
                    }
                }
            }
        };
    }
    if (typeof Alexa.Layouts == 'undefined') {
        Alexa.Layouts = {
            // alexa search page
            'toolbarsearch': {
              'hit': function(doc, url) {
                  var result = url.match(/http:\/\/search\.toolbars\.alexa\.com/i);
                  return result != null;
              },
              'collect': function(doc, url, http) {
                  function monitor(doc, url, http) 
                  {
                    var results = [ ];
                    var nodes   = [ ];
                    var current = null;
                    
                    var div = doc.getElementById('results');
                    
                    if ( div )
                    {
                      var ols = div.getElementsByTagName('ol');
                      
                      for (var i = 0; i < ols.length; i++) 
                      {
                        var ol = ols[i];
                        var lis = ol.getElementsByTagName('li');
                        
                        for (var j = 0; j < lis.length; j++)
                        {
                          var li = lis[j];
                          var as = li.getElementsByTagName('a');
                          
                          var insert = null;
                          var uri = null;
                          
                          for (var k = 0; k < as.length; k++)
                          {
                            var a = as[k];
                            if ( a.className == "visible-url" )
                            {
                              try {
                                insert = a;
                                var p = insert.parentNode;
                                uri   = p.getElementsByTagName( 'A'  )[ 0 ].href;
                              } catch (e) {
                                continue;
                              }
                            }
                          }
                          
                          if(uri && insert)
                                results.push(new Alexa.Results
                                                .Result(doc,
                                                        uri,
                                                        insert));
                        }
                      }
                    } else
                      window.setTimeout( function() { monitor(doc, url, http); }, 500);
                    Alexa.Results.sendResult( doc, results, url, http );
                  }
                  monitor(doc, url, http);
                  return [];
              }
            },
            // chinese search engine
            'baidu': {
              'hit': function(doc, url) {
                  var result = url.match(/http:\/\/www\.baidu\.com\/s\?/i);
                  return result != null;
              },
              'collect': function(doc, url, http) {
                  var results = [];
                  var nodes = [];
                  var current = null;
                  
                  var tables = doc.getElementsByTagName('table');
                  
                  for (var i = 0; i < tables.length; i++) 
                  {
                    var table = tables[i];
                    var tds = table.getElementsByTagName("td");
                    
                    for (var j = 0; j < tds.length; j++)
                    {
                      var td = tds[j];
                      var className = td.className;
                      
                      if ( className && className == "f" )
                      {
                        var fonts = td.getElementsByTagName('font');
                        
                        var uri = null;
                        var insert = null;
                        
                        for (var k = 0; k < fonts.length; k++)
                        {
                          var font = fonts[k];
                          if (font.color == "#008000")
                          {
                            insert = font;
                            break;
                          }
                        }
                        
                        if (insert)
                        {
                          try 
                          {
                            uri = insert.parentNode.parentNode.getElementsByTagName( 'A'  )[ 0 ].href
                          } catch (e) {
                            uri = null;
                          }
                        }
                        
                        if(uri && insert)
                          results.push(new Alexa.Results
                                          .Result(doc,
                                                  uri,
                                                  insert));
                      }
                    }                    
                  }
                  return results;
              }
            },
            'sogou': {
              'hit': function(doc, url) {
                  var result = url.match(/http:\/\/www\.sogou\.com\/web\?/i);
                  return result != null;
              },
              'collect': function(doc, url, http) {
                  var results = [];
                  var nodes = [];
                  var current = null;
                  
                  var tables = doc.getElementsByTagName('table');
                  
                  for (var i = 0; i < tables.length; i++) 
                  {
                    var table = tables[i];
                    var tds = table.getElementsByTagName("td");
                    
                    for (var j = 0; j < tds.length; j++)
                    {
                      var td = tds[j];
                      var className = td.className;
                      
                      if ( className && className == "f" )
                      {
                        var fonts = td.getElementsByTagName('font');
                        
                        var uri = null;
                        var insert = null;
                        
                        for (var k = 0; k < fonts.length; k++)
                        {
                          var font = fonts[k];
                          if (font.color == "#008000")
                          {
                            insert = font;
                            break;
                          }
                        }
                        
                        if (insert)
                        {
                          try 
                          {
                            uri = insert.parentNode.parentNode.getElementsByTagName( 'A'  )[ 0 ].href
                          } catch (e) {
                            uri = null;
                          }
                        }
                        
                        if(uri && insert)
                          results.push(new Alexa.Results
                                          .Result(doc,
                                                  uri,
                                                  insert));
                      }
                    }                    
                  }
                  return results;
              }
            },
            'youdao': {
              'hit': function(doc, url) {
                  var result = url.match(/http:\/\/www\.youdao\.com\/search\?/i);
                  return result != null;
              },
              'collect': function(doc, url, http) {
                  var results = [];
                  var nodes = [];
                  var current = null;
                  
                  var ul = doc.getElementById('results');
                  if ( ul )
                  {
                    var ps = ul.getElementsByTagName('p');
                    for (var i = 0; i < ps.length; i++) 
                    {
                      var p = ps[i];
                      
                      if (p.className == "s")
                      {
                        var spans = p.getElementsByTagName('span');
                        for(var j = 0; j < spans.length; j++)
                        {
                          var span = spans[j];
                          
                          if( span.className == "l")
                          {
                            try {
                              var uri = span.parentNode.parentNode
                                        .getElementsByTagName( 'H3' )[ 0 ]
                                        .getElementsByTagName( 'A'  )[ 0 ].href;
                            } catch (e) {
                              try {
                                var uri = span.parentNode.parentNode.parentNode
                                          .getElementsByTagName( 'H3' )[ 0 ]
                                          .getElementsByTagName( 'A'  )[ 0 ].href;
                              } catch (e) {
                                var uri = null;
                              }
                            }
                            var insert = span;
                            if(uri && insert)
                              results.push(new Alexa.Results
                                              .Result(doc,
                                                      uri,
                                                      insert));
                            
                          }
                        }
                      }
                    }
                  }
                  return results;
              }
            },
            'gougou': {
              'hit': function(doc, url) {
                  var result = url.match(/http:\/\/web\.gougou\.com\/search\?/i);
                  return result != null;
              },
              'collect': function(doc, url, http) {
                  var results = [];
                  var nodes = [];
                  var current = null;
                  
                  var divs = doc.getElementsByTagName('div');
                  
                  for (var i = 0; i < divs.length; i++) 
                  {
                    var div = divs[i];
                    
                     
                    if (div.className == "ggResultItem")
                    {
                      var addresses = div.getElementsByTagName('address');
                      
                      var insert = null;
                      var uri = null;
                      
                      if ( addresses && addresses.length > 0)
                      {
                        insert = addresses[0];
                        try {
                          uri = insert.parentNode
                                    .getElementsByTagName( 'H3' )[ 0 ]
                                    .getElementsByTagName( 'A'  )[ 0 ].href;
                        } catch (e) {
                          uri = null;
                        }
                        
                        if(uri && insert)
                          results.push(new Alexa.Results
                                          .Result(doc,
                                                  uri,
                                                  insert));
                      }    
                        
                      
                    }
                    
                  }
                  return results;
              }
            },
            'yahoocn': {
              'hit': function(doc, url) {
                  var result = url.match(/http:\/\/(search|one)\.cn\.yahoo\.com\/(search|s)\?/i);
                  return result != null;
              },
              'collect': function(doc, url, http) {
                  var results = [];
                  var nodes = [];
                  var current = null;
                  
                  var divs = doc.getElementsByTagName('div');
                  
                  for (var i = 0; i < divs.length; i++) 
                  {
                    var div = divs[i];
                    
                    if (div.className == "yst-web")
                    {
                      var lis = div.getElementsByTagName('li');
                      
                      for (var j = 0; j < lis.length; j++)
                      {
                        var li = lis[j];
                        
                        var ems = li.getElementsByTagName('em');
                        
                        var insert = null;
                        var uri = null;
                        
                        if (ems.length > 0)
                        {
                          insert = ems[0];
                          try {
                            uri = insert.parentNode
                                        .getElementsByTagName( 'H3' )[ 0 ]
                                        .getElementsByTagName( 'A'  )[ 0 ].href;
                          } catch (e) {
                            uri = null;
                          }
                          
                          if(uri && insert)
                            results.push(new Alexa.Results
                                                  .Result(doc,
                                                          uri,
                                                          insert));
                        }
                      }
                    }
                    
                  }
                  return results;
              }
            },
            // global search engine
            'google': {
                'hit': function(doc, url) {
		    var re=/https?:\/\/www\d*(?=\.l)?\.google\..*/i;
                    var result = url.match(re);
                    return result != null;
                },
                'collect': function(doc, url, http) {
                  function monitor(doc, url, http) 
                  {
                    var results = [];
                    var nodes = [];
                    var current = null;
		    /*                   
                    var ols = doc.getElementsByTagName('ol');
		   
                    if (ols.length > 0)
                    {
                      for (var i = 0; i < ols.length; i++) 
                      {
                        var ol = ols[i];
                        var lis = ol.getElementsByTagName('li');
                        var str = [];
                        for (var j = 0; j < lis.length; j++) 
                        {
                          var li = lis[j];
			 
                          if ( li.className == "g" ) 
                          {
                            var cites = li.getElementsByTagName('cite');
			  
                            if (cites && cites.length > 0)
                            {
                              var cite = cites[0]
                              var uri  = cite;
                              while (uri.parentNode && uri.tagName != 'LI') {
                                uri = uri.parentNode;
                              }
                              try {
                               results.push(new Alexa.Results.Result(doc,
                                                        uri.getElementsByTagName('H3')[0].getElementsByTagName('A')[0].href,
                                                        cite));
                              } catch (e) {
                                continue;
                              }
                            }
                          }
                        }
                      }
                    }
		    */
		    var res=doc.getElementById("res");
		    var nUrls=0;
		    if(res && !doc.getElementById("sparkyWidget"))		     
		    {
			
			var Hs=res.getElementsByTagName("h3");
		
			//alert(H3s.length);
			for (i in Hs){
			    if (i==0){
				sparky=doc.createElement("<div id=\"sparkyWidget\" style=\"visibility:none;\">");
				Hs[i].parentNode.insertBefore(sparky);
			    }
			    if(Hs[i].className == "r"){
				try{
				    var cites=Hs[i].parentNode.getElementsByTagName("cite");
				    if(cites.length==1){
					// this is a single "standard" result
	 
					results.push(new Alexa.Results.Result(doc, Hs[i].getElementsByTagName('A')[0].href, cites[0]));
					nUrls++;
				    }
				    /*
				    else{
					// this is something else news/local/similar
					
					for (j in cites){
					    var citeurl=cites[j].innerHTML;
					    if(citeurl ){
						citeurl=citeurl.replace(/(<[^>]+>)/g, "");
						if(citeurl.length > 0){
						citeurl = "http://" + citeurl + "/"
						try{
						results.push(new  Alexa.Results.Result(doc, citeurl, cites[j]));
						}
						catch(e){}
						}
					    }
					}
					
				    }
				    */
				}
				catch(e){
				}
			    }
			    
			}
			if(nUrls > 0){
			    var lb = url;
			    // url="http://www.google.com/search?";
			    var start = "0";
			    try {
				var s = lb.match(/.*(\&|\?)start=(.*?)\&/)[2];
				s = decodeURIComponent(s);
				start = s.replace(/\+/g," ");
				
			    } catch (e) {}
			    var q = "";
			    try { 
				var gbar = doc.getElementById("gb_2");
				var imagesHref = gbar.href;
			       
				q = imagesHref.match(/.*(\&|\?)q=(.*?)\&/)[2];
				q = decodeURIComponent(q);
				q = q.replace(/\+/g, " ");
			    } catch (e) {};
			    var uq = "";
			    try {
				var grey = doc.getElementById("grey");
				uq = grey.parentNode.nextSibling.innerHTML;
			    } catch (e) {};
			    var ct = new Date(); ct = String(ct.getTime());
			    // var ver="__PLUGIN__REPORTING__PLACEHOLDER__";
			    // ver=window.external.replacePlaceholders(ver);
			    // var aid=_AID_;
			    // aid=window.external.replacePlaceholders(aid);
			    var urlArgs=[
					 "lb="    + encodeURIComponent(lb),
					 "start=" + start,
					 "q="     + q,
					 "uq="    + uq,
					 "ct="    + ct,
					 
					 ];
			    url="www.google.com/search?" + _XTRA_ + urlArgs.join("&");  
			    Alexa.Results.sendResult( doc, results, url, http );
			}
 		    }
                  
		    window.setTimeout( function() { monitor(doc, url, http); }, 500);
                  }
                  monitor(doc, url, http);
                  return [];
                }
            }, 
            'yahoo': {
                'hit': function(doc, url) {
                    var result = url.match(/http:\/\/.*search\.yahoo\.com\/search/i);
                    return result != null;
                },
                'collect': function(doc, url, http) {
                    var results = [];
                    var nodes = [];
                    var current = null;
                    var special = new RegExp( /http.*(.*wrs|\.rds|rds|rdrw\d)\.yahoo\.com/i );
                    var isDirty = function( url ) {
                      if( special.exec( url ) != null ) {
                        return true;
                      }
                      return false;
                    };
                    
                    var div = doc.getElementById('results');
                    
                    if (div)
                    {
                      ols = div.getElementsByTagName('ol')
                      for (var i = 0; i < ols.length; i++) 
                      {
                        var ol = ols[i];
                        var lis = ol.getElementsByTagName('li');
                        
                        for (var j = 0; j < lis.length; j++) 
                        {
                          var li = lis[j];
                          var divs2 = li.getElementsByTagName('div');
                          for (var k = 0; k < divs2.length; k++)
                          {
                            var div2 = divs2[k];
                            if (div2.className.indexOf( "res" ) != -1)
                            {
                              //window.alert(div2.className);
                              var as = div2.getElementsByTagName('a');
                              var spans = div2.getElementsByTagName('span');
                              
                              var uri = null;
                              var insert = null;
                              
                              for (var l = 0; l < as.length; l++)
                              {
                                var a = as[l];
                                if ( a.className.indexOf( "yschttl" ) != -1)
                                {
                                  //window.alert(a.className);
                                  uri = a.href;
                                  break;
                                }
                              }
                              for (var l = 0; l < spans.length; l++)
                              {
                                var span = spans[l];
                                if (span.className == "url")
                                {
                                  insert = span;
                                  break;
                                }
                              }
                              
                              if (uri && insert)
                              {
                                if( isDirty( uri ) ) {
                                  var tmp = insert.innerText;
                                  uri     = 'http://' + tmp;
                                  if( tmp.indexOf( '/' ) < 0 ) {
                                    uri   = uri + '/';
                                  }
                                }
                                
                                results.push(new Alexa.Results
                                                       .Result(doc,
                                                                uri,
                                                                insert));
                              }
                            }
                          }
                        }                     
                      }
                    }
                    return results;
                }
            },
            'msn|live': {
                'hit': function(doc, url) {
                    var result = url.match(/http:\/\/.*search\.msn|live\.com\/results.aspx\?|http:\/\/www\.bing\.com\/search/i);
                    return result != null;
                },
                'collect': function(doc, url, http) {
                    var results = [];
                    var nodes = [];
                    var current = null;
                    
                    var div = doc.getElementById('results');
		    if(div) {
			var uls = div.getElementsByTagName('ul');
                    
			for (var i = 0; i < uls.length; i++) {
			    var ul = uls[i];
			    if (ul.className == "sb_results") {
				//var lis = ul.getElementsByTagName('li');
				for (var li = ul.firstChild; li != null; li = li.nextSibling) {
				    //var li = lis[j];
				    var cites = li.getElementsByTagName("cite")
					if ( cites && cites.length > 0 ){
					    var cite = cites[0];
					    //window.alert(cite.innerText);
					    try {
						var uri   = cite.parentNode.parentNode.parentNode;
					    } catch (e){
						var uri = null;
					    }
					    try {
						results.push(new Alexa.Results
							     .Result(doc,
								     uri.getElementsByTagName('H3')[0].getElementsByTagName('A')[0].href,
								     cite.parentNode));
					    } catch (e) {
						continue;
					    }
					}
				}
			    }                      
			}
		    }
                    return results;
                }
            },
            'ask': {
                'hit': function(doc, url) {
                    var result = url.match(/http:\/\/.*www\.ask\.com\/web\?/i);
                    return result != null;
                },
                'collect': function(doc, url, http) {
                    var results = [];
                    var nodes = [];
                    var current = null;
                    
                    var tables = doc.getElementsByTagName('table');
                    
                    for (var i = 0; i < tables.length; i++) 
                    {
                      var table = tables[i];
                      if (table.id == "result-table")
                      {
                        var divs = table.getElementsByTagName("div");

                        for (var j = 0; j < divs.length; j++)
                        {
                          var div = divs[j];
                          var className = div.className;
                          
                          if ( className && className.indexOf("pad") != -1 && className.indexOf("pr10") != -1)
                          {
                            var as = div.getElementsByTagName('a');
                            var spans = div.getElementsByTagName('span');
                            
                            var uri = null;
                            var insert = null;
                            
                            for (var k = 0; k < as.length; k++)
                            {
                              var a = as[k];
                              if (a.className == "L4")
                              {
                                uri = a.href;
                                break;
                              }
                            }
                            for (var k = 0; k < spans.length; k++)
                            {
                              var span = spans[k];
                              if (span.className == "T10")
                              {
                                insert = span;
                                break;
                              }
                            }
                            
                            if(uri && insert)
                              results.push(new Alexa.Results
                                              .Result(doc,
                                                      uri,
                                                      insert));
                          }
                        }
                      }
                    }
                    return results;
                }
            }
        };
    }
    if (typeof Alexa.Targets == 'undefined') {
        Alexa.Targets = function() {
            return this;
        };
        Alexa.Targets.prototype = {
            'findTarget': function(doc, url, http) {
                var target = null;
                var result = null;
                for (var i in Alexa.Layouts) {
                    target = Alexa.Layouts[i];
                    if (target.hit(doc, unescape(url))) {
                        return target.collect(doc, url, http);
                    }
                }
                return [];
            }
        };
        Alexa.Targets = new Alexa.Targets();
    }
})();