/******************
 * Liangnan Wu *
 * Alexa Internet *
 ******************/

var ALX_NS_PH_SPARKLINE = {
  baseline: "http://data.alexa.com/data",
  datafeed: null,
  dnsService: null,
  urlService: null,
  sessionService: null,
  nativeJSON: null,
  stringBundle: null,
  need_data: true,
  configured: false,
  active_buttons: "",
  giResponseTimeOut: 3000,
  giUrls: null,

  trace: function(msg)
  {
    Components.classes["@mozilla.org/consoleservice;1"]
              .getService(Components.interfaces.nsIConsoleService)
              .logStringMessage("<"+String(msg)+">");
  },

  getTime: function()
  {
    var t = new Date();
    return t.getTime();
  },

  logStartTime: function(url, doc)
  {
    var targetBrowserIndex = gBrowser.getBrowserIndexForDocument(doc);
    if (targetBrowserIndex != -1 && url)
    {
      var tab = gBrowser.tabContainer.childNodes[targetBrowserIndex];
      var loadTimeData = {url: url, startTime: ALX_NS_PH_SPARKLINE.getTime(), loadTime: null}
      ALX_NS_PH_SPARKLINE.sessionService.setTabValue( tab, "ALX_NS_PH.loadTime", ALX_NS_PH_SPARKLINE.nativeJSON.encode(loadTimeData) );
    }

  },

  logEndTime: function(url, doc)
  {
    var targetBrowserIndex = gBrowser.getBrowserIndexForDocument(doc);
    if (targetBrowserIndex != -1 && url)
    {
      var tab = gBrowser.tabContainer.childNodes[targetBrowserIndex];
      var loadTimeData = this.sessionService.getTabValue( tab, "ALX_NS_PH.loadTime" );
      if (loadTimeData)
      {
        loadTimeData = this.nativeJSON.decode(loadTimeData);

        loadTimeData.loadTime = ALX_NS_PH_SPARKLINE.getTime() - loadTimeData.startTime;
        if (loadTimeData.loadTime > 0)
        {
          ALX_NS_PH_SPARKLINE.sessionService.setTabValue( tab, "ALX_NS_PH.loadTime", ALX_NS_PH_SPARKLINE.nativeJSON.encode(loadTimeData) );
          return;
        }
      }
      loadTimeData = {url: null, startTime: null, loadTime: null}
      ALX_NS_PH_SPARKLINE.sessionService.setTabValue( tab, "ALX_NS_PH.loadTime", ALX_NS_PH_SPARKLINE.nativeJSON.encode(loadTimeData) );
    }
  },

  isAlexaHost: function(host)
    { return host && String(host).match(/^(?:.*\.)?alexa\.com$/i); },

  isAlexa: function(url)
  {
    try
    {
      return url
          && url.host
          && this.isAlexaHost( url.host )
           ;
    }
    catch(ex) { return false; }
  },

  parameterize: function(search)
  {
     if ( search.length > 0 && '?' == search[0] ) search = search.substr(1);
     var results = {};
     var parameters = search.split(/&/);
     for ( var i = 0 ; i < parameters.length ; ++i )
     {
       var idx = parameters[i].indexOf('=');
       var key = (-1!=idx)
               ? decodeURIComponent( parameters[i].substring(0,idx) )
               : decodeURIComponent( parameters[i] )
               ;
       var val = (-1!=idx)
               ? decodeURIComponent( parameters[i].substring(idx+1) )
               : null
               ;
       if ( ! results[key] ) results[key] = val;
     }
     return results;
  },

  extractHost: function(url)
  {
    if ( url && url.match(/^https?:\/\//i) )
    try
    {
      return this.urlService.newURI(
                  url,
                  undefined,
                  null
                 ).host;
    } catch(ex) { }
    return null;
  },

  updateSparkline: function(data)
  {
    var src = data.blocked               ? "chrome://ALX_NS_PH/skin/ip-blocked.png"
            : this.isAlexaHost(data.site) ? "chrome://ALX_NS_PH/skin/installed.png"
            : data.site                   ? "http://widgets.alexa.com/traffic/sparky/?v=1&url=" + encodeURIComponent( data.site )
            : /* else */                   "chrome://ALX_NS_PH/skin/default.png"
            ;
    var img = document.getElementById("ALX_NS_PH_SB-sparkline");
    if ( img && img.src != src ) img.src = src;
  },

  navigate: function(browser,url)
    { browser.selectedTab = browser.addTab(url); },

  navigateTo: function(url)
    { this.navigate(getBrowser(),url); },

  navigateWithUrl: function(prefix,suffix)
  {
    var context = ALX_NS_PH_SPARKLINE.okUrl(ALX_NS_PH_SPARKLINE.currentUrl());
    if ( context )
      context = ( context.schemeIs("http")  ) ? ALX_NS_PH_SPARKLINE.getSpec(context)
              : ( context.schemeIs("https") ) ? "https://" + ALX_NS_PH_SPARKLINE.getHost(context) + "/"
              :                                 undefined
              ;

    if ( content )
    ALX_NS_PH_SPARKLINE.navigate( getBrowser(), prefix + encodeURIComponent(context) + suffix);
  },

  navigateWithHost: function(prefix)
  {
    var hostname = ALX_NS_PH_SPARKLINE.getHost(ALX_NS_PH_SPARKLINE.okUrl(ALX_NS_PH_SPARKLINE.currentUrl()));
    var context = ( prefix.indexOf('?') > -1 )
                ? encodeURIComponent(hostname)
                : hostname
                ;
    this.navigate( getBrowser(), prefix + context );
  },

  menuitemsDisabled: function(state)
  {
    var menuitems = document.getElementById("ALX_NS_PH_SB")
                            .getElementsByAttribute("class","ALX_NS_PH_SB-menuitem")
                            ;
    for ( var i = 0 ; i < menuitems.length ; ++i )
      { menuitems[i].setAttribute('disabled',state); }
  },

  getHost: function(url) { try { return url ? url.host : null; } catch(ex) { return undefined; } },
  getSpec: function(url) { try { return url ? url.spec : null; } catch(ex) { return undefined; } },
  getPath: function(url) { try { return url ? url.path : null; } catch(ex) { return undefined; } },

  getScheme: function(url) { try { return url ? url.scheme : null; } catch(ex) { return undefined; } },

  updateFuzzyMenu: function(url)
  {
    var menuitems = document.getElementById("ALX_NS_PH_SB")
                            .getElementsByAttribute("class","ALX_NS_PH_SB-fuzzy")
                            ;
    var hostname = this.getHost(url);
    for ( var i = 0 ; i < menuitems.length ; ++i )
    {
      menuitems[i].setAttribute('disabled',!hostname);
      if ( menuitems[i].value )
        menuitems[i].setAttribute('label', menuitems[i].value + ( hostname ? hostname : "this site." ));
    }
  },

  oneshot: function(obj,type,func,args)
  {
    var loader = function(event)
      { obj.removeEventListener(type,loader,true); func(args); }
    obj.addEventListener(type,loader,true);
  },

  navigateOnLoad: function(browser,location)
  {
    this.oneshot( browser,
                  "load",
                  function()
                    { ALX_NS_PH_SPARKLINE.navigate(browser,location); }
                );
  },

  resolveEndpoint: function()
  {
    var pref = "session";
    var aid = "";
    if (this.branch.prefHasUserValue(pref))
    {
      aid = this.branch.getCharPref(pref);
    }
    this.set_aid(aid);
  },

  set_aid: function(aid)
  {
    var version = this.alexaUtilityService.getMyVersion();
    this.datafeed = this.baseline + "/" + aid
                                  + "?cli=10"
                                  + "&ver=" + version
                                  + "&dat=ns";

    this.aid = aid;
    if (this.first_window)
    {
      this.configure(window.content.location.href);
    }
  },

  selectRank: function(number)
  {
    number = +number;
    return number ==      0 ? "x"
         : number <=    100 ? "f"
         : number <=    180 ? "e"
         : number <=    320 ? "d"
         : number <=    560 ? "c"
         : number <=   1000 ? "b"
         : number <=   1800 ? "a"
         : number <=   3200 ? "9"
         : number <=   5600 ? "8"
         : number <=  10000 ? "7"
         : number <=  18000 ? "6"
         : number <=  32000 ? "5"
         : number <=  56000 ? "4"
         : number <= 100000 ? "3"
         : number <= 180000 ? "2"
         : number <= 320000 ? "1"
         :                    "0"
         ;
  },

  format: function(n)
  {
    if ( ! n ) return "0"; 
    var x = n.length % 3 ;
    var a = !x ? [] : [ n.substr(0,x) ];
    for ( var i = x ; i < n.length ; i += 3 )
      a[a.length] = n.substr(i,3);

    return a.join(',');
  },

  lastUrlRendered: undefined,
  
  getStringBundle: function()
  {
    if (!this.stringBundle)
    {
      var bundleService = Components.classes["@mozilla.org/intl/stringbundle;1"]
          .getService(Components.interfaces.nsIStringBundleService);
      /*var categoryManager = Components.classes["@mozilla.org/categorymanager;1"]
          .getService(Components.interfaces.nsICategoryManager);
      categoryManager.addCategoryEntry("strings_alexa", "chrome://ALX_NS_PH/locale/branding.properties", "", true, true);*/
      this.stringBundle = bundleService.createBundle("chrome://ALX_NS_PH/locale/branding.properties");
      //this.stringBundle = bundleService.createExtensibleBundle("strings_alexa");

      //this.stringBundle = document.getElementById("stringbundle-overlay1");
      //ALX_NS_PH_SPARKLINE.trace("heiheihei: " + this.stringBundle);
    }
    return this.stringBundle;
  },

  getBundleString: function(name)
  {
    return this.getStringBundle().GetStringFromName(name);
  },

  renderXml: function(url,ref,tab,data,self)
  {
    if ( tab.selected && url !== self.lastUrlRendered )
    if ( url == null || url == self.getSpec(self.okUrl(self.currentUrl())) )
    {
      ALX_NS_PH_SPARKLINE.updateSparkline(data);
      self.configure(url);

      if (null==url) { self.menuitemsDisabled(true); }

      var showRanks = self.branch.getBoolPref("ranks");
      var frank = data.rank ? self.format(data.rank) : null; /*fep*/
      data.showRanks = showRanks;
      var rankText
        =  !showRanks ? (ALX_NS_PH_SPARKLINE.getBundleString('disabled'))
        : self.urlService.offline ? ALX_NS_PH_SPARKLINE.getBundleString('offline')
        : data.blocked ? ALX_NS_PH_SPARKLINE.getBundleString('clickforhelp')
        : !url       ? ALX_NS_PH_SPARKLINE.getBundleString('private')
        :  url.match(/^http:\/\/(www\.)?alexa\.com\/toolbar\/(success|final)/)
                     ? ALX_NS_PH_SPARKLINE.getBundleString('success')
        :  self.isAlexaHost( data.site )
                     ? ALX_NS_PH_SPARKLINE.getBundleString('notranked')
        : !data.rank ? ALX_NS_PH_SPARKLINE.getBundleString('norank')
        : /* else */   "#"+frank
        ;
      document.getElementById("ALX_NS_PH_SB-rank-text").value = rankText;
      data.rankText = rankText;

      document.getElementById("ALX_NS_PH_SB-rank-image").src
        = "chrome://ALX_NS_PH/skin/rank/" 
        + self.selectRank( data.rank )
        + ".png"
        ;

      document.getElementById("ALX_NS_PH_SB-icon")
              .setAttribute("tooltiptext", ALX_NS_PH_SPARKLINE.getBundleString('find_more_about').replace(/__SITE__/gi, (data.site?data.site:"Alexa!")) );

      var ranktip =  !showRanks ? (ALX_NS_PH_SPARKLINE.getBundleString('disabled'))
                  :  self.urlService.offline
                               ? (ALX_NS_PH_SPARKLINE.getBundleString('offline'))
                  : data.blocked ? (ALX_NS_PH_SPARKLINE.getBundleString('ipblock'))
                  : !url       ? (ALX_NS_PH_SPARKLINE.getBundleString('privatesite'))
                  : !data.site ? (ALX_NS_PH_SPARKLINE.getBundleString('norankdata'))
                  :  self.isAlexaHost( data.site )
                               ? (ALX_NS_PH_SPARKLINE.getBundleString('notranked'))
                  : !data.rank ? (ALX_NS_PH_SPARKLINE.getBundleString('rank_not_available_for').replace(/__SITE__/gi, data.site))
                  : /* else */   (ALX_NS_PH_SPARKLINE.getBundleString('rank_for').replace(/__SITE__/gi, data.site) + ": " + frank )
                  ;
      document.getElementById("ALX_NS_PH_SB-rank").setAttribute("tooltiptext",ranktip);
      document.getElementById("ALX_NS_PH_SB-rank-text").setAttribute("tooltiptext",ranktip);
      document.getElementById("ALX_NS_PH_SB-rank-image").setAttribute("tooltiptext",ranktip);
      data.rankTip = ranktip;

      document.getElementById("ALX_NS_PH_SB-sparkline")
              .setAttribute("tooltiptext", !self.need_data ? (ALX_NS_PH_SPARKLINE.getBundleString('disabled'))
                                         : self.urlService.offline ? (ALX_NS_PH_SPARKLINE.getBundleString('offline'))
                                         : data.blocked ? (ALX_NS_PH_SPARKLINE.getBundleString('ipblock'))
                                         : !url       ? (ALX_NS_PH_SPARKLINE.getBundleString('privatesite'))
                                         : !data.site ? (ALX_NS_PH_SPARKLINE.getBundleString('notrenddata'))
                                         :  self.isAlexaHost( data.site )
                                                      ? (ALX_NS_PH_SPARKLINE.getBundleString('notranked'))
                                         : /* else */   (ALX_NS_PH_SPARKLINE.getBundleString('six_month_trend').replace(/__SITE__/gi, data.site))
                                         );

      if (self.branch.getBoolPref("reviews"))
      {
        data.averageReview = data.averageReview ? data.averageReview : "unrated";
      }
      else
      {
        data.averageReview = "disabled";
      }

      data.disabled = !self.need_data;

      var alexastatusbar = document.getElementById("ALX_NS_PH_SB");
      if (data.blocked)
      {
        alexastatusbar.setAttribute("onclick", "if (event.button == 0) { ALX_NS_PH_SPARKLINE.navigateTo('http://' + decodeURIComponent('" + encodeURIComponent(data.related[0].link) + "')); } ");
        alexastatusbar.removeAttribute("popup");
        document.getElementById("ALX_NS_PH_SB-rank-image").hidden = true;
      }
      else
      {
        alexastatusbar.setAttribute("onclick", "");
        alexastatusbar.setAttribute("popup", "ALX_NS_PH_SB-icon-menu");
        document.getElementById("ALX_NS_PH_SB-rank-image").hidden = false;
      }
      
      ALX_NS_PH_TB.updateButtons(data);

      self.lastUrlRendered = url;

      if (null!=url) { self.menuitemsDisabled(false); }


    }
  },

  pullXml: function(doc,xpath,def)
  {
    try
    {
      var res = doc.evaluate(xpath,doc,null,XPathResult.STRING_TYPE,null).stringValue;
      return res.length>0 ? res : def;
    } catch(ex) { return String(ex); }
  },

  getId: function(tab)
  {
    var str = tab.linkedPanel
            ? String(tab.linkedPanel)
            : ""
            ;

    var val = str.length;

    for ( var i = str.length - 1 ; i >= 0 ; --i )
      val = ( val * 7919 + str.charCodeAt(i) * 128 ) % 32768;

    return val;
  },

  loadXml: function(url,ref,tab,cnt,m,statusCode,method)
  {    
    var cdt = [ "rq%3D" + cnt, "wid%3D" + this.getId(tab) ];
    if (statusCode)
    {
      cdt.push(encodeURIComponent("s=" + encodeURIComponent(statusCode)));
    }
    if (method && method != "GET")
    {
      cdt.push(encodeURIComponent("m=" + encodeURIComponent(method)));
    }

    var loadTimeData = this.sessionService.getTabValue( tab, "ALX_NS_PH.loadTime" );
    if (loadTimeData)
    {
      loadTimeData = this.nativeJSON.decode(loadTimeData);
      if ( loadTimeData.loadTime)
        cdt.push(encodeURIComponent("ttl=" + encodeURIComponent(loadTimeData.loadTime)));
      loadTimeData = {url: null, startTime: null, loadTime: null}
      ALX_NS_PH_SPARKLINE.sessionService.setTabValue( tab, "ALX_NS_PH.loadTime", ALX_NS_PH_SPARKLINE.nativeJSON.encode(loadTimeData) );
    }
    var src = ( url && this.need_data )
            ? this.datafeed + "&cdt=" + cdt.join("%26")
                            + "&ref=" + ( ref ? encodeURIComponent( this.getSpec(ref)  ) : "" )
                            + "&url=" + ( url ? encodeURIComponent( url ) : "" )
            : "chrome://ALX_NS_PH/content/default.xml"
            ;

    if (ALX_NS_PH_TB.events())
    {
      if (this.branch.getBoolPref("usage-stats"))
      {
        this.alexaUtilityService.log("events", "act=" + ALX_NS_PH_TB.events());
      }
      ALX_NS_PH_TB.clear_events();
    }

    var self = this;
    var http = new XMLHttpRequest();
    http.open( "GET", src, true );
    var callback = function()
    {
      var data =
      {
        url:   url,
        cnt:   url ? cnt + 1 : cnt,
        rank:  null,
        site:  null,
        title: null,
        delta: 0,
        averageReview: "unrated",
        related: [ ],
        blocked: false,
        contact: {}
      };
      if ( "OK" == http.statusText )
      {
        data.rank  = self.pullXml( http.responseXML, "//SD/POPULARITY/@TEXT", data.rank );

        try
        {
          var links = http.responseXML.evaluate("//RLS/RL",http.responseXML,null,XPathResult.ORDERED_NODE_SNAPSHOT_TYPE,null);
          if ( links )
          for ( var i = 0 ; i < links.snapshotLength ; ++i )
          {
            var link = links.snapshotItem(i);
            data.related[data.related.length] =
            {
              name: String(link.getAttribute("TITLE")),
              link: String(link.getAttribute("HREF"))
            };
          }

          if (data.related.length == 1 && data.related[0].link && data.related[0].link.match(/^www\.alexa\.com\/blocker/) && !data.site)
          {
            data.blocked = true;
          }
        } catch(ex) { }

        data.title = self.pullXml( http.responseXML, "//SD/TITLE/@TEXT", data.title );
        data.site  = self.pullXml( http.responseXML, "//SD/AMZN/@URL", data.site );
        data.site  = self.pullXml( http.responseXML, "//SD/@HOST", data.site );
        data.site  = self.pullXml( http.responseXML, "//SD/POPULARITY/@URL", data.site );
        data.delta = parseInt(self.pullXml( http.responseXML, "//SD/RANK/@DELTA", "0" ), 10);
        data.contact.street   = self.pullXml( http.responseXML, "//SD/ADDR/@STREET", data.contact.street );
        data.contact.city     = self.pullXml( http.responseXML, "//SD/ADDR/@CITY", data.contact.city );
        data.contact.state    = self.pullXml( http.responseXML, "//SD/ADDR/@STATE", data.contact.state );
        data.contact.zip      = self.pullXml( http.responseXML, "//SD/ADDR/@ZIP", data.contact.zip );
        data.contact.country  = self.pullXml( http.responseXML, "//SD/ADDR/@COUNTRY", data.contact.country );
        data.contact.owner    = self.pullXml( http.responseXML, "//SD/OWNER/@NAME", data.contact.owner );
        data.contact.email    = self.pullXml( http.responseXML, "//SD/EMAIL/@ADDR", data.contact.email );

        if ( data.site && data.site.indexOf('/') > -1 )
          data.site = data.site.substr(0,data.site.indexOf('/'));
        data.averageReview  = self.pullXml( http.responseXML, "//SD/REVIEWS/@AVG", "unrated" );
      }
      self.renderXml(url,ref,tab,data,self);
      self.sessionService.setTabValue( tab, "ALX_NS_PH.data", self.nativeJSON.encode(data) );
    };
    http.onload = callback;
    try
    {
      http.send( null );
    } catch(ex) { callback(); }
  },

  updateXml: function(url,ref,tab,render,statusCode,method)
  {
    if (url) url = this.getSpec(url);
    var data = this.sessionService.getTabValue( tab, "ALX_NS_PH.data" );
    if (data)
      data = this.nativeJSON.decode(data);
    if ( data == undefined || url != data.url )
      { this.loadXml(url,ref,tab,data!=undefined && data.cnt ? data.cnt : 0,this,statusCode,method); }
    else
    { 
      if (!data)
        data = {};

      var showRanks = this.branch.getBoolPref("ranks");
      data.showRanks = showRanks;
      this.sessionService.setTabValue( tab, "AMAZON_NS_PH.data", this.nativeJSON.encode(data) );
      render(url,ref,tab,data,this); 
    }
  },

  clearMenu: function(menu)
  {
    while ( menu.childNodes.length > 0 )
      { menu.removeChild( menu.childNodes.item(0) ); }
  },

  updateRelatedLinks: function(id, self, moreRelatedLinksText, disableText, notAvailabeText, loadingText)
  {
    if (!moreRelatedLinksText)
      moreRelatedLinksText = ALX_NS_PH_SPARKLINE.getBundleString('relatedlink');
    if (!disableText)
      disableText = "disabled";
    if (!notAvailabeText)
      notAvailabeText = "Not Available";
    if (!loadingText)
      loadingText = "loading";

    var current = this.getSpec(this.okUrl(this.currentUrl()));
    if ( self.value != current )
    {
      this.clearMenu(self);
      var data = this.sessionService.getTabValue( getBrowser().selectedTab, "ALX_NS_PH.data" );
      if (data)
        data = this.nativeJSON.decode(data);
      var disabled = !this.branch.getBoolPref("alexa-relatedlinks");

      if ( !disabled && data.url && data.url != current )
      {
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute("label","[" + loadingText + "]");
        menuitem.setAttribute("disabled",true);
        self.appendChild(menuitem);
        self.value = null;
      }
      else
      if ( !data.related || data.related.length == 0  || disabled)
      {
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute("label", disabled ? "[" + disableText + "]" : "[" + notAvailabeText + "]");
        menuitem.setAttribute("disabled",true);
        self.appendChild(menuitem);
        self.value = null;
      }
      else
      {
        for ( var i = 0 ; i < data.related.length ; ++i )
        {
          var menuitem = document.createElement("menuitem");
          menuitem.setAttribute("crop","end");
          menuitem.setAttribute("label",data.related[i].name);
          menuitem.setAttribute("class","menuitem-iconic alexa-favicon");
          menuitem.setAttribute("image","http://"+this.extractHost("http://" + data.related[i].link)+"/favicon.ico");
          menuitem.setAttribute("value","http://"+data.related[i].link);
          menuitem.setAttribute("tooltiptext",data.related[i].name + "\nhttp://"+ data.related[i].link);
          menuitem.setAttribute("oncommand","ALX_NS_PH_TB.log('" + id + ":i'); ALX_NS_PH_SPARKLINE.navigateTo('http://' + decodeURIComponent('" + encodeURIComponent(data.related[i].link) + "')); event.stopPropagation();");
          self.appendChild(menuitem);
        }
        self.appendChild( document.createElement("menuseparator") );
        var menuitem = document.createElement("menuitem");
        menuitem.setAttribute("label", moreRelatedLinksText);
        menuitem.setAttribute("class","menuitem-iconic alexa-favicon");
        menuitem.setAttribute("image","chrome://ALX_NS_PH/skin/icon.ico");
        menuitem.setAttribute("oncommand","ALX_NS_PH_TB.log('" + id + ":i'); ALX_NS_PH_SPARKLINE.navigateWithUrl('http://www.alexa.com/siteinfo/','#relatedlinks'); event.stopPropagation();");
        self.appendChild(menuitem);
        self.value = current;
      }
    }
  },

  md5: function(str)
  {
    try
    {
      var hash = Components.classes["@mozilla.org/security/hash;1"]
                           .createInstance(Components.interfaces.nsICryptoHash)
                           ;
      hash.init(hash.MD5);
      hash.update(str.split(''),str.length);
      return hash.finish(true);
    } catch(ex) { return null; }
  },

  anonymizeUrl: function(url)
    { return "https://"+url.hostname+"/"+this.md5(String(url.pathname)) + "#anonymous"; },

  massageUrl: function(url)
  {
    try
    {
      return url.protocol == "http:"  ? this.urlService.newURI(url.toString(),undefined,null)
           : url.protocol == "https:" ? this.urlService.newURI(this.anonymizeUrl(url),undefined,null)
           : /* else */                 null
           ;
    } catch(ex) { return null; }
  },

  currentUrl: function()
  {
      var url = this.herb.getCurrentUrl(window.content.location.href);
      return url ? String(url) : null;
  },

  convertUrl: function(url)
  {
    if ( url && url.match(/^https?:\/\//i) )
    try
    {
      url = this.urlService.newURI(
              url,
              undefined,
              null
            );
      return { hostname: this.getHost(url),
               pathname: this.getPath(url),
               protocol: this.getScheme(url) + ":",
               _string_: this.getSpec(url),
               toString: function() { return String(this._string_); }
             };
    } catch(ex) { };
    return null;
  },
  
  okUrl: function(url)
  {
    try
    {
      if ( ! url ) return null;
      if ( ! ( url.hostname && url.pathname && url.protocol ) )
        url = this.convertUrl( url );

      if ( ! url || ! url.hostname ) return null;
      return this.massageUrl(url);
    } catch(ex) { return null; }
  },

  lastUrlUpdated: undefined,
  update: function(url,ref,tab)
  {
    if ( url === this.lastUrlUpdated ) return; else this.lastUrlUpdated = url;
    url = this.okUrl(url);
    ref = this.okUrl(ref);
    var statusCode = "";
    var method = "";
    
    if (tab.selected)
    {
      function update(url, isIntranet) {
        if (tab.selected)
        {
          url = isIntranet ? null : url;
          ALX_NS_PH_SPARKLINE.updateFuzzyMenu(url);
          ALX_NS_PH_SPARKLINE.updateXml(url,ref,tab,ALX_NS_PH_SPARKLINE.renderXml,statusCode,method);
        }
        tab = null;
      }      

      // Extract URLs from error pages
      var docuri = window.content.document.documentURI;
      var err_prefix = "about:neterror?e="
      if (docuri && docuri.indexOf(err_prefix) == 0 && docuri.indexOf("&") > err_prefix.length)
      {
        statusCode = docuri.substr(err_prefix.length, docuri.indexOf("&") - err_prefix.length);
      }
      else
      {
        var response = this.sessionService.getTabValue(tab, "ALX_NS_PH.final-response");
        if (response)
          response = this.nativeJSON.decode(response);
        var spec = this.getSpec(url);
        if (!response || response.URI != spec)
        {
          response = this.sessionService.getTabValue(tab, "ALX_NS_PH.response");
          if (response)
            response = this.nativeJSON.decode(response);
        }
        if (response && response.URI == spec)
        {
          statusCode = response.responseStatus;
          method = response.requestMethod;
        }
      }

      // If the domain doesn't exist, don't bother checking whether it's an intranet URL
      if (statusCode == "dnsNotFound" || !url)
      {
        update(url, false);
        return;
      }

      this.alexaUtilityService.checkIntranet(url, update);
    }

  },

  showAbout: function()
    { window.openDialog('chrome://ALX_NS_PH/content/about.xul','alexa-toolbar-about','chrome,centerscreen,resizable=no,dependent=yes'); },

  showOptions: function()
    { window.openDialog('chrome://ALX_NS_PH/content/options.xul','alexa-toolbar-options','chrome,centerscreen,resizable=no,dependent=yes'); },

  showHelp: function()
    { window.content.location = "http://www.alexa.com/help"; },

  observe: function(subject, topic, data)
  {
    if (topic == "nsPref:changed")
    {
      this.readPrefs();

      if (data == "extensions.alexa.giurls.giResponseTimeOut")
        ALX_NS_PH_SPARKLINE.giResponseTimeOut = this.branch.getIntPref("giurls.giResponseTimeOut");
      if (data == "extensions.alexa.giurls.giUrls")
        ALX_NS_PH_SPARKLINE.giUrls = ALX_NS_PH_SPARKLINE.nativeJSON.decode(this.branch.getCharPref("giurls.giUrls"));

      // Log enabling and disabling of features
      var aid = "";
      if (this.branch.prefHasUserValue("session"))
      {
        aid = this.branch.getCharPref("session");
      }
      if (data == "extensions.alexa.session" && aid && aid != "=")
      {
        this.set_aid(aid);
      }
      if (data.match(/^extensions\.alexa\.active-buttons(\.[^.]+)?$/))
      {
        if ( data == "extensions.alexa.active-buttons")
        {
          var MY_ID = "toolbar@alexa.com";
          var active_buttons_after = ALX_NS_PH_SPARKLINE.branch.getCharPref("active-buttons")
          var active_buttons_before = ALX_NS_PH_SPARKLINE.active_buttons;

          var active_buttons_after_list = active_buttons_after.split(",");
          var active_buttons_before_list = active_buttons_before.split(",");
          
          var map_after = {};
          for (var key in active_buttons_after_list)
          {
            var value = active_buttons_after_list[key];
            if (value)
              map_after[value] = true;
          }
          for (var key in active_buttons_before_list)
          {
            var value = active_buttons_before_list[key];
            if (value && typeof map_after[value] == "undefined")
            {
              var tmpD = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("TmpD", Ci.nsIFile)
              tmpD.append("alexa");tmpD.append(MY_ID);tmpD.append("2.01");tmpD.append("buttons");
              var filePathTmp = tmpD.path;
              var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
              file.initWithPath(filePathTmp);
              if ( file.exists() )
                file.remove(true);
            }
          }
          
          ALX_NS_PH_SPARKLINE.active_buttons = active_buttons_after;
        }
        ALX_NS_PH_TB.extension.init();
      }
      if (data == "extensions.alexa.display-style")
      {
        this.setupDisplayStyle();
      }
    }
  },
  
  setupDisplayStyle: function()
  {
    try
    {
      if (this.branch.getCharPref("display-style") == "statusbar")
      {
        document.getElementById("ALX_NS_PH_SB").hidden = false;
        document.getElementById("ALX_NS_PH_SB-rank").hidden = false;
        document.getElementById("ALX_NS_PH_SB-sparkline").hidden = false;
        document.getElementById("ALX_NS_PH_TB-Toolbar").collapsed = true;            
        document.getElementById("ALX_NS_PH_TB-Toolbar").setAttribute("toolbarname","");
      }
      else
      {
        document.getElementById("ALX_NS_PH_SB").hidden = true;
        var toolbar = document.getElementById("ALX_NS_PH_TB-Toolbar");
        toolbar.collapsed = false;
        toolbar.setAttribute("toolbarname", toolbar.getAttribute("toolbarname2"));
      }
    }
    catch (ex)
    {
    }
  },
  
  readPrefs: function( )
  {
    try
    {
      document.getElementById("alexa-relatedlinks").hidden = !this.branch.getBoolPref("alexa-relatedlinks");
    }
    catch (ex)
    {
    }

    try
    {
      if ( (!document.getElementById("ALX_NS_PH_SB").hidden && !document.getElementById("ALX_NS_PH_TB-Toolbar").collapsed ) )
      {
        this.setupDisplayStyle();
      }

      if (!document.getElementById("ALX_NS_PH_SB").hidden)
      {
        document.getElementById("ALX_NS_PH_TB-Toolbar").setAttribute("toolbarname","");
      }
    }
    catch (ex)
    {
    }

    var needed_data = this.need_data;
    this.need_data = this.alexaUtilityService.needDataRequests();

    // Update Sparkline as soon as the feature is enabled
    if (this.need_data && !needed_data && window.content)
    {
      this.lastUrlUpdated = null;
      this.update( this.currentUrl(),
                   window.content.document.referrer,
                   getBrowser().selectedTab );
    }
  },

  configure: function(url)
  {
    if (!this.configured)
    {
      var environment = Components.classes["@mozilla.org/process/environment;1"].
          getService(Components.interfaces.nsIEnvironment);

      var isFirst = false;
      if (!environment.exists("ALX_NS_PH_first_window"))
        isFirst = true;
      else
      {
        var ALX_NS_PH_first_window = environment.get("ALX_NS_PH_first_window");
        if (ALX_NS_PH_first_window != "taken")
            isFirst = true;
      }


      if ( isFirst )
      {
        this.first_window = true;
        environment.set("ALX_NS_PH_first_window", "taken");
      }

      if (this.aid && this.aid != "=" && this.first_window)
      {
        var demographics_uri = this.branch.getCharPref("install.demographics-uri");
        
        // get locale information
        var locale = null;
        if ( this.prefs.prefHasUserValue("extensions.alexa.toolbarLocale") )
        {
          locale = this.prefs.getCharPref("extensions.alexa.toolbarLocale").toLowerCase();
          if (locale != "default") {
            try {
              demographics_uri = this.branch.getCharPref("install.demographics-uri." + locale);
            } catch(e) {}
          }
        } else {
          locale = this.prefs.getCharPref("general.useragent.locale").toLowerCase();
          var lang = locale.split("-")[0];

          try {
            demographics_uri = this.branch.getCharPref("install.demographics-uri." + locale);
          } catch(e) {
            try {
              demographics_uri = this.branch.getCharPref("install.demographics-uri." + lang);
              locale = lang;
            } catch (e) {}
          }
        }
        
        if (locale != "default") {
          var prefCount = {value:0};
          var directoriesList = this.branch.getChildList(locale + ".", prefCount);
          
          for (var i = 0; i < directoriesList.length; ++i)
          {
            var key = directoriesList[i];
            var value = this.branch.getBoolPref(key);
            key = key.replace(locale + ".", "");
            this.branch.setBoolPref(key, value);
          }
        }

        var version = this.alexaUtilityService.getMyVersion();
        demographics_uri = demographics_uri.replace("__AID__PLACEHOLDER__", this.aid);
        demographics_uri = demographics_uri.replace("__VERSION__PLACEHOLDER__", version);
        var pref = "demographics-session";
        if (!this.branch.prefHasUserValue(pref) || this.branch.getCharPref(pref) != this.aid)
        {
          // Step 1: Popup demographics window
          this.branch.setCharPref(pref, this.aid);
          this.navigate(getBrowser(), demographics_uri);
        }
        else if (url == demographics_uri)
        {
          // Step 2: Focus demographics window when it's loaded
          window.content.focus();
        }
        else if (url)
        {
          ALX_NS_PH_SPARKLINE.trace("here");
          // Step 3: Popup configuration dialog
          this.configured = true;
          var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                       . getService(Components.interfaces.nsIPrefService);
          var branch = prefs.getBranch("extensions.alexa.");
          var item = document.getElementById("ALX_NS_PH_SB");
          
          var showPostInstallBubble = true;
          try {
            showPostInstallBubble = branch.getBoolPref('showPostInstallBubble');
          } catch (e) {}
          
          if ( showPostInstallBubble && (!branch.prefHasUserValue('configured2') || !branch.getBoolPref('configured2')))
          {
            if (item && !item.hidden)
            {
              this.popup_sparkline_configuration(item);
            }
            else if (!document.getElementById("ALX_NS_PH_TB-Toolbar").collapsed)
            {
              ALX_NS_PH_TB.popup_configuration();
            }
          }
        }
      }
    }
  },

  popup_sparkline_configuration: function(item)
  {
    var panel = document.getElementById("ALX_NS_PH_SB-install-bubble-panel");
    try
    {
      var offset_y = 0;
      if (Components.classes["@mozilla.org/webshell;1"])
      {
        // Firefox 3.5 and earlier treat offsets differently
        offset_y += 9;
      }
      panel.openPopup(item, "before_end", 10, offset_y, false, true);
    }
    catch(e)
    {
      this.trace(e);
    }
  },

  reporterListener: {
    QueryInterface: function(aIID) {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener)   ||
          aIID.equals(Components.interfaces.nsIWebProgressListener2)  ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
        return this;
      throw Components.results.NS_NOINTERFACE;
    },

    onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus)
    {
      if (aStateFlags & Ci.nsIWebProgressListener.STATE_START)
      {
        var currentURI = aWebProgress["currentURI"];
        var doc = aWebProgress["document"];

        if (currentURI && doc && aRequest)
        {
          ALX_NS_PH_SPARKLINE.logStartTime(aRequest.name, doc);
        }
      }
    },
    onLocationChange: function(aProgress, aRequest, aURI) {},
    onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) { },
    onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) { },
    onSecurityChange: function() { },//ALX_NS_PH_SPARKLINE.trace("onSecurityChange"); },
    onProgressChange64: function() { },//ALX_NS_PH_SPARKLINE.trace("onProgressChange64"); },
    onRefreshAttempted: function() { return true; }//ALX_NS_PH_SPARKLINE.trace("onRefreshAttempted"); return true; }
  }, 

  init: function()
  {
    this.dnsService = Components.classes["@mozilla.org/network/dns-service;1"].getService( Components.interfaces.nsIDNSService );
    this.urlService = Components.classes["@mozilla.org/network/io-service;1"].getService( Components.interfaces.nsIIOService );
    this.nativeJSON = Components.classes["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON);
    this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
                 . getService(Components.interfaces.nsIPrefService);
    this.branch = this.prefs.getBranch("extensions.alexa.");
    this.herb = Components.classes["@ALX_NS_PH/herb;1"].createInstance( Components.interfaces.nsIAlexaHerbService );
    this.sessionService = Components.classes["@mozilla.org/browser/sessionstore;1"].getService( Components.interfaces.nsISessionStore );
    this.alexaUtilityService = Components.classes["@ALX_NS_PH/utility-service;1"].createInstance( Components.interfaces.nsIAlexaUtilityService );
    this.alexaUtilityService.requestSession();
    this.resolveEndpoint( );

    var version = this.alexaUtilityService.getMyVersion();
    if ( "AMAZON_NS_PH" != "ALX_NS_PH" ) 
      this.prefs.getBranch("general.useragent.extra.").setCharPref("ALX_NS_PH", "AlexaToolbar/" + version);

    try
    {
      this.active_buttons = this.branch.getCharPref("active-buttons");
    } catch(ex) {
      this.active_buttons = "";
    }

    if ( (!this.branch.prefHasUserValue("version") || this.branch.getCharPref("version") != version) &&
         this.branch.prefHasUserValue("session") && this.branch.getCharPref("session").length != 0 )
    {
      var environment = Components.classes["@mozilla.org/process/environment;1"].
            getService(Components.interfaces.nsIEnvironment);
      var aid = this.branch.getCharPref("session");
      var uri = this.branch.getCharPref("install.upgrade-uri"); 
      var locale = null;
      if ( this.prefs.prefHasUserValue("extensions.alexa.toolbarLocale") )
      {
        locale = this.prefs.getCharPref("extensions.alexa.toolbarLocale").toLowerCase();
        if (locale != "default") {
          try {
            uri = this.branch.getCharPref("install.upgrade-uri." + locale);
          } catch(e) {}
        }
      } else {
        locale = this.prefs.getCharPref("general.useragent.locale").toLowerCase();
        var lang = locale.split("-")[0];
 
        try {
          uri = this.branch.getCharPref("install.upgrade-uri." + locale);
        } catch(e) {
          try {
            uri = this.branch.getCharPref("install.upgrade-uri." + lang);
            locale = lang;
          } catch (e) {}
        }
      }
      
      if (locale != "default") {
        var prefCount = {value:0};
        var directoriesList = this.branch.getChildList(locale + ".", prefCount);
        for (var i = 0; i < directoriesList.length; ++i)
        {
          var key = directoriesList[i];
          var value = this.branch.getBoolPref(key);
          key = key.replace(locale + ".", "");
          this.branch.setBoolPref(key, value);
        }
      }
 
      this.branch.setCharPref("active-buttons", "");
      this.branch.setBoolPref("configured2", false);
      var MY_ID = "toolbar@alexa.com";
      var tmpD = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("TmpD", Ci.nsIFile)
      tmpD.append("alexa");tmpD.append(MY_ID);tmpD.append("2.01");
      var filePathTmp = tmpD.path;

      var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
      file.initWithPath(filePathTmp);
      if ( file.exists() )
        file.remove(true);
      
      if (environment.exists("ALX_NS_PH_first_window"))
      {
        this.first_window = false;
        environment.set("ALX_NS_PH_first_window", "untaken");
      }

      uri = uri.replace("__AID__PLACEHOLDER__", aid);
      uri = uri.replace("__VERSION__PLACEHOLDER__", version);
      this.navigateOnLoad(getBrowser(), uri);
      this.setupDisplayStyle();
    }
    this.branch.setCharPref("version", version);
    this.branch.setCharPref("toolbarLocaleChange", "");
    gBrowser.addProgressListener(ALX_NS_PH_SPARKLINE.reporterListener);

    Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch2).addObserver("extensions.alexa.", this, false);
    this.readPrefs( );

    if (this.branch.prefHasUserValue('disabled'))
    {
      // Looks like the user re-enabled the toolbar
      this.branch.setBoolPref("disabled", false); 
    }
    if (this.branch.prefHasUserValue('uninstall'))
    {
      // Looks like the user re-installed the toolbar
      this.branch.setBoolPref("uninstall", false); 
    }
    if (this.branch.prefHasUserValue('giurls.giResponseTimeOut'))
    {
      ALX_NS_PH_SPARKLINE.giResponseTimeOut = this.branch.getIntPref("giurls.giResponseTimeOut");
    }
    if (this.branch.prefHasUserValue('giurls.giUrls'))
    {
      ALX_NS_PH_SPARKLINE.giUrls = ALX_NS_PH_SPARKLINE.nativeJSON.decode(this.branch.getCharPref("giurls.giUrls"));
    }

    window.document.addEventListener( "pageshow", function(event) { 
      if (window.content)
        ALX_NS_PH_SPARKLINE.update( ALX_NS_PH_SPARKLINE.currentUrl(),
                               window.content.document.referrer,
                               getBrowser().selectedTab );
    }, true );
    gBrowser.tabContainer.addEventListener( "TabSelect", function(event) { 
      if (window.content)
        ALX_NS_PH_SPARKLINE.update( ALX_NS_PH_SPARKLINE.currentUrl(),
                               window.content.document.referrer,
                               getBrowser().selectedTab );
    }, true );
    window.document.addEventListener( "DOMContentLoaded", function( evt ) {
      if( evt.originalTarget instanceof HTMLDocument ) {
        if (evt.originalTarget.defaultView.top.location.href == evt.originalTarget.location.href)
        {
          ALX_NS_PH_SPARKLINE.logEndTime( evt.originalTarget.location.href, evt.originalTarget);
        }
        ALX_NS_PH_SPARKLINE.update( ALX_NS_PH_SPARKLINE.currentUrl(),
                               window.content.document.referrer,
                               getBrowser().selectedTab );

        var owner = window.alexa_searchrank_owner;

        if (ALX_NS_PH_SPARKLINE.giUrls)
        for (var i = 0; i < ALX_NS_PH_SPARKLINE.giUrls.length; ++i)
        {
          var regx = new RegExp(ALX_NS_PH_SPARKLINE.giUrls[i], "i");
          var uri = new String( evt.originalTarget.location );
          if ( uri.match(regx) )
          {
            evt.originalTarget.addEventListener('DOMSubtreeModified', function (event) {
              if (event.target.id == "search" || event.target.id == "topstuff")
              {
                if ( ALX_NS_PH_SPARKLINE.branch.getBoolPref('searchranks') )
                {
                  var mock_event = {
                    'target': event.target.ownerDocument,
                    'originalTarget': evt.originalTarget
                  };
                  ALX_NS_PH.Results.onload( mock_event);
                  ALX_NS_PH.ReBrandedLinks.onload( mock_event );
                }
                var t = new Date();
                t = t.getTime() + 3000;
                ALX_NS_PH_SPARKLINE.googleUrlChange = t;

                var func = function () {
                  var t = new Date();
                  t = t.getTime();
                  if (ALX_NS_PH_SPARKLINE.googleUrlChange == null)
                    return;

                  if (t >= ALX_NS_PH_SPARKLINE.googleUrlChange)
                  {
                    ALX_NS_PH_SPARKLINE.googleUrlChange = null;
                    ALX_NS_PH_SPARKLINE.update( ALX_NS_PH_SPARKLINE.currentUrl(),
                                 window.content.document.referrer,
                                 getBrowser().selectedTab );
                  } else
                  {
                    window.setTimeout(func, ALX_NS_PH_SPARKLINE.googleUrlChange - t);
                  }
                };

                func();
              }
            }, false);
          }
        }

        if (ALX_NS_PH_SPARKLINE.branch.getBoolPref('searchranks'))
        {
          if (!owner)
            window.alexa_searchrank_owner = "ALX_NS_PH";
          if (!owner || owner == "ALX_NS_PH")
          {
            ALX_NS_PH.Results.onload( evt, true );
            ALX_NS_PH.ReBrandedLinks.onload( evt );
            if (ALX_NS_PH.Layouts.google.hit(evt.originalTarget))
            {
              evt.originalTarget.addEventListener('DOMAttrModified', function (event) {
                if (event.target.id == 'foot') {
                  var mock_event = {
                    'target': event.target.ownerDocument,
                    'originalTarget': evt.originalTarget
                  };
                  ALX_NS_PH.Results.onload( mock_event );
                  ALX_NS_PH.ReBrandedLinks.onload( mock_event );
                }
              }, false);
            }
          }
        }
        else if (owner == "ALX_NS_PH")
        {
          window.alexa_searchrank_owner = "";
        }
 
        // Check for windows created by Alexa Toolbar, and add in some extra features for these windows
        if (evt.originalTarget.defaultView && evt.originalTarget.defaultView.wrappedJSObject)
        {
          var jsWin = evt.originalTarget.defaultView.wrappedJSObject;
          if (!window.ALX_NS_PH_TB_arguments && jsWin.arguments && jsWin.arguments.length && jsWin.arguments[0].ALX_NS_PH_TB)
          {
            window.ALX_NS_PH_TB_arguments = jsWin.arguments;
          }
          if (window.ALX_NS_PH_TB_arguments)
          {
            jsWin.arguments = window.ALX_NS_PH_TB_arguments;
            jsWin.close = function() { window.close(); }
          }
        }
      }
    }, true );
  },

  shutdown: function()
  {
    gBrowser.removeProgressListener(ALX_NS_PH_SPARKLINE.reporterListener);
    Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch2).removeObserver("extensions.alexa.", this);
  }

};
window.addEventListener( "load", function(event) { ALX_NS_PH_SPARKLINE.init(); }, false );
window.addEventListener( "unload", function(event) { ALX_NS_PH_SPARKLINE.shutdown(); }, false);

/* end
 *****/
