
(function ( )  {
  var alexaUtilityService = Cc["@ALX_NS_PH/utility-service;1"].createInstance(Ci.nsIAlexaUtilityService);
  if( typeof ALX_NS_PH == 'undefined' ) {
    window.ALX_NS_PH = { };
  }
  function log( msg ) {
    dump( 'Alx.Results: ' +  msg + "\n" );
  }
  function props( msg ) {
    var msg = [ ];
    for( i in msg ) {
      msg.append( i );
    }
    log( msg + ': ' + msg.join( '\n' ) );
  }
  function resolver( name ) {
    return ({
      'alexa' : "http://rdf.alexa.com/terms/",
      'rdf'   : "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
      'xlink' : "http://www.w3.org/1999/xlink",
    })[ name ];
  }
  if( typeof ALX_NS_PH.Prefs == 'undefined' ) {
    ALX_NS_PH.Prefs = { 'root': Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService)
                  };
    ALX_NS_PH.Prefs.branches = { 'alexa' : ALX_NS_PH.Prefs.root
                                            .getBranch("extensions.alexa."),
                             'gp'    : ALX_NS_PH.Prefs.root
                                            .getBranch("extensions.googlepreview."),
                           };

  }
  if( typeof ALX_NS_PH.Results == 'undefined' ) {
    ALX_NS_PH.Results = {
      'Ranks': {
        '0': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAHhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXsGjI9e%2Bf%2F%2FzJkzQw6DYxAUaiBPxLT%2BB3vk379%2FROH%2FgwiA%2FIDhkUHkPqKdAvYILGnBYoRo3YNIIThpDavMTkLpS3JRSq%2FiFwAICgd0Cacy%2FAAAAABJRU5ErkJggg%3D%3D',
        '1': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAHhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXsGAx%2B98v%2F%2FmTNnhgQGxyAo1EAeiWn9j4JBHvn37x9O%2FH8QAZAf8HpkELkVr1PAHoElLWwxMlQ8Ak5awyqzk1D6klyU0qv4BQA6wPrJb7boYwAAAABJRU5ErkJggg%3D%3D',
        '2': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAHhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXsGLz565f%2F%2FM2fODFoMjkFQqIE8EtP6HycGeeTfv38o%2BP8gAiA%2FEO2RQeRuDKeAPQJLWoRiZDB7BJy0hlVmJ6H0JbkopVfxCwAE1e4t58bljwAAAABJRU5ErkJggg%3D%3D',
        '3': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXuGaHz0yv%2F%2FZ86cGVQYHIOgUAN5JKb1P1EY5JHBBkB%2BGD4egSWtoRwj4KQ1rDI7CaUvyUUpvYpfAHFf4ZScMb22AAAAAElFTkSuQmCC',
        '4': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXuGLHz0yv%2F%2FZ86cGXAMjkFQqIE8EtP6n2QM8shgACA%2FDB%2BPwJLWUI4RcNIaVpmdhNKX5KKUXsUvAEjY1O%2BFuTVlAAAAAElFTkSuQmCC',
        '5': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXuGYnz0yv%2F%2FZ86cGRAMjkFQqIE8EtP6nyIM8shAAZAfho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXALgNyEpAkh30AAAAAElFTkSuQmCC',
        '6': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXuGqvjolf%2F%2Fz5w5QzcMjkFQqIE8EtP6n2oY5BF6ApAfho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXAL8Nu6VXRZL3AAAAAElFTkSuQmCC',
        '7': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXuGpvjolf%2F%2Fz5w5QzMMjkFQqIE8EtP6n2YY5BFaApAfho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXAF8pqsmhgU10AAAAAElFTkSuQmCC',
        '8': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXuGbvjolf%2F%2Fz5w5Q1UMjkFQqIE8EtP6ny4Y5BFqA5Afho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXAMhEniSmhHINAAAAAElFTkSuQmCC',
        '9': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtmQPDRK%2F%2F%2FnzlzhmIMjkFQqIE8EtP6n%2B4Y5BFqAJAfho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXAMkqkX92ldzlAAAAAElFTkSuQmCC',
        'a': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtmwPHRK%2F%2F%2FnzlzhiwMjkFQqIE8EtP6f0AxyCPkApAfho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXAGHbhNpTRCMEAAAAAElFTkSuQmCC',
        'b': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtmUOGjV%2F7%2FP3PmDNEYHIOgUAN5JKb1%2F6DBII%2BQAkB%2BGD4egSWtoRwj4KQ1rDI7CaUvyUUpvYpfAJJIeDVXZ2naAAAAAElFTkSuQmCC',
        'c': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtm0OKjV%2F7%2FP3PmDF4MjkFQqIE8EtP6f1BikEcIAZAfho9HYElrKMcIOGkNq8xOQulLclFKr%2BIXAFqAa5AouaEoAAAAAElFTkSuQmCC',
        'd': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGhJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtmSOCjV%2F7%2FP3PmDAYGxyAo1EAeiWn9P%2BgxyCPYAMgPw8cjsKQ1lGMEnLSGVWYnofQluSilV%2FELALp0XutkZ4L7AAAAAElFTkSuQmCC',
        'e': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGdJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtmyOGjV%2F7%2FP3PmDBiDYxAUaiCPxLT%2BH1IY5BEYAPlh%2BHgElrSGcoyAk9awyuwklL4kF6X0Kn4BsjNSRpUhqycAAAAASUVORK5CYII%3D',
        'f': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAGFJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaHlnXtmyOKjV%2F6DA4sBFGogj8S0%2Fh%2BSGOQRkB%2BGj0dgSWsoxwg4aQ2rzE5C6UtyUUqv4hcAq65J2G2I%2FpYAAAAASUVORK5CYII%3D',
        'x': 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAADIAAAAICAYAAAC73qx6AAAABGdBTUEAALGPC%2FxhBQAAABh0RVh0U29mdHdhcmUAUGFpbnQuTkVUIHYzLjA4ZXKc4QAAAFtJREFUOE9jaGho%2BM9AAiBVPchoUvWQpR6kCYS7uvsJYphaYtWDzCRVD7nqwaG1adOmIY3BMQgKNZBHzpw5M2QxyA%2FDxyOwpDWUYwSctIZVZieh9CW5KKVX8QsAwVisZtvfQcsAAAAASUVORK5CYII%3D',
        
      },
      'rank2code': function( rank ) {
        rank = +rank;
        return rank ==      0 ? 'x'
             : rank <=    100 ? 'f'
             : rank <=    180 ? 'e'
             : rank <=    320 ? 'd'
             : rank <=    560 ? 'c'
             : rank <=   1000 ? 'b'
             : rank <=   1800 ? 'a'
             : rank <=   3200 ? '9'
             : rank <=   5600 ? '8'
             : rank <=  10000 ? '7'
             : rank <=  18000 ? '6'
             : rank <=  32000 ? '5'
             : rank <=  56000 ? '4'
             : rank <= 100000 ? '3'
             : rank <= 180000 ? '2'
             : rank <= 320000 ? '1'
             :                  '0'
             ;


      },
      'sendResult' : function ( results, referUrl )
      {
        var current = null;
        var uris    = [ ];
        for( var x = 0; results && x < results.length; x++ ) {
          current = results[ x ];
          log( 'result: ' + current.href );
          uris.push( current.href );
        }
        if( uris.length == 0 )
          return true;
          
        var http = new XMLHttpRequest( );
        if (referUrl)
          var uri = 'http://widgets.alexa.com/traffic/rankr/?ref=' 
                  + encodeURIComponent( referUrl );
        else
          var uri = 'http://widgets.alexa.com/traffic/rankr/?ref=' 
                  + encodeURIComponent( window.content.location.href );
        http.open( 'POST', uri, true);
        http.setRequestHeader( 'accept', 'application/xml' );
        http.setRequestHeader( 'User-Agent', 
                               'Alexa/Sparky/' 
                             + alexaUtilityService.getMyVersion( ) );

        http.onreadystatechange = function( ) {
          if( http.readyState == 4 && http.status == 200 ) {
            //log( "" );
            //log( http.responseText );
            //log( "" );
            var xml     = http.responseXML;
            var current = null;
            var cursor  = null;
            var rank    = null;
            var site    = null;
            var info    = null;
            for( var x = 0; x < results.length; x++ ) {
              current = results[ x ];
              cursor  = xml.evaluate( "//alexa:site[ @rdf:about ="
                                    + "//alexa:page[ @rdf:about = '"
                                    + current.href          + "' ]"
                                    + "/alexa:site/@rdf:resource ]",
                                      xml, resolver, XPathResult.ANY_TYPE, null );
              info  = cursor.iterateNext( );
              try {
              rank  = info.attributes.getNamedItemNS( resolver( 'alexa' ),
                                                      'rank' ).textContent;
              site  = info.attributes.getNamedItemNS( resolver( 'rdf' ),
                                                      'about' ).textContent;
              } catch( e ) {
                rank = 0;
                site = current.href;
              }
              current.rank = rank;
              current.addRank( rank, site );
              log( site + ': ' + rank )
            }

          }
        };
        http.send( uris.join( "\n" ) );
      },
      'onload': function ( evt, isOnLoad ) {
        if( !ALX_NS_PH.Prefs.branches.alexa.getBoolPref( 'searchranks' ) )
          return true;
        var results = ALX_NS_PH.Targets.findTarget( evt.target );  
        if (results.length <= 0)
          return;
          
        if (ALX_NS_PH.Layouts.google.hit(evt.originalTarget) && !isOnLoad)
        {
          var func  = function() {
            var doc = evt.target;
            var lb = doc.location.href;
            
            var start = "0";
            try {
              var start = lb.match(/.*(\&|\?)start=(.*?)\&/)[2];
              start = decodeURIComponent(s);
              start = s.replace(/\+/g," ");
            } catch (e) {}
            
            var q = "";
            try { 
              var imagesLink = doc.getElementById("gbar").getElementsByTagName("a")[1];
              var imagesHref = imagesLink.href;
              q = imagesHref.match(/.*(\&|\?)q=(.*?)\&/)[2];
              q = decodeURIComponent(q);
              q = q.replace(/\+/g," ");
            } catch (e) {};
            
            var uq = "";
            try {
              var grey = doc.getElementById("grey");
              uq = grey.parentNode.nextSibling.textContent;
            } catch (e) {};
            
            var ct = new Date(); ct = String(ct.getTime());
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
            var branch = prefs.getBranch("extensions.alexa.");
            var aid = "";
            if ( branch.prefHasUserValue("session") ) 
              aid = branch.getCharPref("session");
            var ver = "";
            if ( branch.prefHasUserValue("version") ) 
              ver = branch.getCharPref("version");
            
            var referp = [
              "lb="    + encodeURIComponent(lb),
              "start=" + start,
              "q="     + q,
              "uq="    + uq,
              "ct="    + ct,
              "ver="   + ver,
              "aid="   + aid
            ];

            var referUrl = "http://" + doc.location.hostname +  "/search?" + referp.join('&');
            ALX_NS_PH.Results.sendResult( results, referUrl);
          }
          window.setTimeout(func, 200);
        }else
          ALX_NS_PH.Results.sendResult( results );
      },
      'Result': function( href, insertion ) {
        this.href      = href;
        var node       = new Image( );
        node.src = ALX_NS_PH.Results.Ranks[ 'x' ];
        node.style.paddingRight = '1ex';
        this.insertion = insertion;
        if( this.insertion ) {
          var first = this.insertion.firstChild;
          this.insertion.insertBefore( node,
                                       first );
          this.insertion = node;
        }
        return this;
      }

    };
    ALX_NS_PH.Results.Result.prototype = {
      'rank'         : null,
      'href'         : null,
      'canonical'    : null,
      'insertion'    : null,
      'addRank'      : function( rank, uri ) {
        rank         = new Number( rank );
        var anchor   = window.content.document.createElement( 'A' );
        var label    = 'Alexa Traffic Rank for ' 
                     + this.href + ': ' 
                     + ( rank > 0 
                       ? rank.toLocaleString( )
                       : 'unavailable' )
                     ;

        var target   = this.href.split( '://' );
        target.shift( )
        target       = target.join( '' ).split( '?' );
        target       = target.length > 1 
                     ? target[ 0 ] + encodeURIComponent( '?' + target[ 1 ] )
                     : target.join( '?' )
                     ;
        anchor.href  = 'http://www.alexa.com/data/details/traffic_details/' 
                     + target;
        anchor.title = label
        anchor.style.paddingRight = "1ex";
        anchor.style.textDecoration = 'none';
        var img      = new Image( );
        img.style.border = 'none';
        img.title    = label;
        img.src      = ALX_NS_PH.Results.Ranks[ ALX_NS_PH
                            .Results.rank2code( rank ) ];
        anchor.appendChild( img );
        this.canonical = uri;
        
        if( this.insertion ) {
          this.insertion.parentNode.replaceChild( anchor, this.insertion );
          this.insertion = anchor;
        }
      }
    };
  }
  if( typeof ALX_NS_PH.Layouts == 'undefined' ) {
    ALX_NS_PH.Layouts = {
      // alexa search page
      'toolbarsearch': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/search\.toolbars\.alexa\.com/i);
           return result != null;
        },
        'collect': function( doc ) {
          function monitor(doc) {
            var results = [ ];
            var nodes   = [ ];
            var current = null;

            var handle  = doc.evaluate( 
                          "//body/div/div/div[ contains( "
                        + "concat( ' ', normalize-space(@id), ' '), "
                        + "' content ')]/div/div/ol/li/a[ contains( "
                        + "concat( ' ', normalize-space(@class), ' '), "
                        + "' visible-url ')]",
                          doc, null, XPathResult.ANY_TYPE, null );
            for( var i = handle.iterateNext( ); i != null; 
                                                i = handle.iterateNext( ) ) {
              nodes.push( i );
            }
            handle  = doc.evaluate( 
                          "//body/div/div/div[ contains( "
                        + "concat( ' ', normalize-space(@id), ' '), "
                        + "' content ')]/div/div/ol/li/span[ contains( "
                        + "concat( ' ', normalize-space(@class), ' '), "
                        + "' visible-url ')]",
                          doc, null, XPathResult.ANY_TYPE, null );
            for( var i = handle.iterateNext( ); i != null; 
                                                i = handle.iterateNext( ) ) {
              nodes.push( i );
            }

            if(nodes.length == 0) {
              window.setTimeout( function() { monitor(doc); }, 500);
              return;
            }
            var uri    = null;
            var insert = null;
            for( var i = 0; i < nodes.length; i++ ) {
              current = nodes[ i ];
              try {
                insert = current;
                var p = current.parentNode;
                uri   = p.getElementsByTagName( 'A'  )[ 0 ].href;
                
                results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
              } catch ( e ) { continue; }
            }
            ALX_NS_PH.Results.sendResult( results );
          }
          monitor(doc);
          return [];
        }
      },
      // chinese search engine
      'baidu': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/www\.baidu\.com\/s\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "//table/tbody/tr/td[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' f ')]/font/font[ contains( "
                      + "concat( ' ', normalize-space(@color), ' '), "
                      + "' #008000 ')]",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert = current;
              var p = current.parentNode.parentNode;
              uri   = p.getElementsByTagName( 'A'  )[ 0 ].href;
              
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'soso': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/www\.soso\.com\/q\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "//div/div/table/tbody/tr/td[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' s_l ')]/ol/li/div[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' result_summary ')]/div[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' url ')]/cite",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert = current;
              var p = current.parentNode.parentNode.parentNode;
              uri   = p.getElementsByTagName( 'A'  )[ 0 ].href;
              
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'sogou': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/www\.sogou\.com\/web\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "//table/tbody/tr/td[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' f ')]/font/font[ contains( "
                      + "concat( ' ', normalize-space(@color), ' '), "
                      + "' #008000 ')]",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert = current;
              var p = current.parentNode.parentNode;
              uri   = p.getElementsByTagName( 'A'  )[ 0 ].href;
              
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'youdao': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/www\.youdao\.com\/search\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "//div/div/ul[ contains( "
                      + "concat( ' ', normalize-space(@id), ' '), "
                      + "' results ')]/li/p[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' s ')]/span[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' l ')]",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert = current;
              var p = current.parentNode.parentNode;
              uri   = p.getElementsByTagName( 'H3' )[ 0 ]
                       .getElementsByTagName( 'A'  )[ 0 ].href;
              
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'gougou': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/web\.gougou\.com\/search\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "//div[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' ggResultItem ')]/address",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert = current;
              var p = current.parentNode;
              uri   = p.getElementsByTagName( 'H3' )[ 0 ]
                       .getElementsByTagName( 'A'  )[ 0 ].href;
              
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'yahoocn': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/(search|one)\.cn\.yahoo\.com\/(search|s)\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "//div[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' yst-web ')]/ul/li/em",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert = current;
              var p = current.parentNode;
              uri   = p.getElementsByTagName( 'H3' )[ 0 ]
                       .getElementsByTagName( 'A'  )[ 0 ].href;
              
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      //global search engine
      'msn|live': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/.*search\.msn|live\.com\/results.aspx\?|http:\/\/www\.bing\.com\/search/i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( 
                        "descendant-or-self::*[@id = 'results']"
                      + "/descendant::ul[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' sb_results ')]"
                      + "/descendant::li/descendant::div[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' sa_cc ')]/descendant::div[ contains( "
                      + "concat( ' ', normalize-space(@class), ' '), "
                      + "' sb_meta ')]/descendant::cite",
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              insert  = current.parentNode;
              current = current.parentNode.parentNode.parentNode;
              uri     = current.getElementsByTagName( 'H3' )[ 0 ]
                               .getElementsByTagName( 'A'  )[ 0 ].href;
              log( 'uri: '    + uri );
              log( 'insert: ' + insert + " <" + insert.textContent + ">" );
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'ask': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/.*www\.ask\.com\/web\?/i);
           return result != null;
        },
        'collect': function( doc ) {
          // XXX: This is prone to breakage.
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          var handle  = doc.evaluate( "descendant-or-self::*"
                      + "[@id = 'result-table']/descendant::tr/"
                      + "descendant::td/descendant::div"
                      + "[ contains( "
                      + "    concat(' ', normalize-space(@class), ' '), ' pad ')"
                      + " and ( "
                      + "  contains( "
                      + "    concat(' ', normalize-space(@class), ' '), ' pr10 '))"
                      + "]",
                      /*
                      /descendant::a[ contains( "
                      + "concat(' ', normalize-space(@class), ' '), ' L4 ')]",
                      */
                        doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            // If the result has an id, it's a weird one with no place to stick
            // the rank meter.  Skip it.
            if( i.id != "" ) continue;
            nodes.push( i );
          }
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              handle = doc.evaluate( "./descendant::a[ contains( "
                     +     "concat(' ', normalize-space(@class), ' '), ' L4 ')]/@href",
                           current, null,
                           XPathResult.STRING_TYPE, null );
              uri    = handle.stringValue;                     
              handle = doc.evaluate( "./descendant::span[ contains( "
                     +     "concat(' ', normalize-space(@class), ' '), ' T10 ')]",
                           current, null,
                           XPathResult.FIRST_ORDERED_NODE_TYPE, null );
              if( handle.singleNodeValue  == null )
                continue;
              insert = handle.singleNodeValue;                     
              // Also ignore news results.
              if( !insert.hasAttribute( 'id' ) ) continue;
              log( 'uri: '    + uri );
              log( 'insert: ' + insert + " <" + insert.textContent + ">" );
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
        }
      },
      'yahoo': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/.*search\.yahoo\.com\/search/i);
           return result != null;
        },
        'collect': function( doc ) {
          /*
            div id='results'
              ol
                li
                  div class='res'
                    div
                      h3
                        A class='yschttl'
                    div class='abstr'
                    span class='url'
                      ******
                    A
                    div class='ql'
                    span class='qlmr'
          */
          var results = [ ];
          var nodes   = [ ];
          /* Attempt to deconstruct obfuscated URIs?
          */
          var special = new RegExp( /http.*(.*wrs|\.rds|rds|rdrw\d)\.yahoo\.com/i );
          var isDirty = function( url ) {
            if( special.exec( url ) != null ) {
              return true;
            }
            return false;
          };
          var current = null;
          var handle  = doc.evaluate( "//div[@id='results']"
                      +   "/descendant::ol/li/div[ contains( "
                      +   "concat( ' ', normalize-space(@class), ' ' ),"
                      +   "concat( ' ', 'res',                   ' ' ) "
                      +   "      ) ]",
                          doc, null, XPathResult.ANY_TYPE, null );
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          var uri    = null;
          var insert = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current = nodes[ i ];
            try {
              handle  = doc.evaluate( "./descendant::a[ contains( "
                                    + "concat( ' ', normalize-space(@class), ' ' ),"
                                    + "concat( ' ', 'yschttl',                   ' ' ) "
                                    + ") ]/@href",
                                    current, null, 
                                    XPathResult.STRING_TYPE, null );
              uri     = handle.stringValue;
              log( 'uri: ' + uri );
              handle  = doc.evaluate( "./descendant::span[ contains( "
                                    + "concat( ' ', normalize-space(@class), ' ' ),"
                                    + "concat( ' ', 'url',                   ' ' ) "
                                    + ") ]",
                                    current, null, 
                                    XPathResult.FIRST_ORDERED_NODE_TYPE, null );
              insert  = handle.singleNodeValue;
              if( insert == null )
                continue;
              if( isDirty( uri ) ) {
                var tmp = insert.textContent;
                uri     = 'http://' + tmp;
                if( tmp.indexOf( '/' ) < 0 ) {
                  uri   = uri + '/';
                }
                log( 'new uri: ' + uri );
              }
              log( 'insert: ' + insert.tagName + ': ' + insert );
              results.push( new ALX_NS_PH.Results.Result( uri, insert  ) );
            } catch ( e ) { continue; }
          }
          return results;
          
        }
      },
      'google': {
        'hit': function( doc ) {
           var uri = new String( doc.location );
           var result = uri.match(/http:\/\/www(|[0-9])\.(|l\.)google\..*\//i);
           return result != null;
        },
        'collect': function( doc ) {
          var results = [ ];
          var nodes   = [ ];
          var current = null;
          /*
            ol
              li class='g'
                a
                h3 class='r'
                div class='s'
                  cite
                    ****
                  span class='gl'
          */
          var handle = doc.evaluate( 
          "//div/ol/li[ contains( "
                     +   "concat( ' ', normalize-space(@class), ' ' ),"
                     +   "concat( ' ', 'g',                     ' ' ) "
                     +   "      ) ]//cite",
                     doc, null, XPathResult.ANY_TYPE, null );
          /* We have a requirement to insert a loading graphic before we have
           * the needed metadata. Since modifying any nodes will invalidate the
           * iterator, we must copy all results into a temporary array first.
           */
          for( var i = handle.iterateNext( ); i != null; 
                                              i = handle.iterateNext( ) ) {
            nodes.push( i );
          }
          var uri    = null;
          for( var i = 0; i < nodes.length; i++ ) {
            current  = nodes[ i ];
            try {
              uri      = current;
              while( uri.parentNode && uri.tagName != "LI" && uri.tagName != "SPAN" && uri.tagName != "TABLE")
                uri = uri.parentNode;

              // Skip over news results and video results
              if (uri.tagName != "LI")
                uri = uri.parentNode.parentNode;
                if (uri.tagName != "LI")
                  uri = uri.parentNode
                  if (uri.tagName != "LI")
                    continue

              results.push( new ALX_NS_PH.Results
                                     .Result( uri
                                              .getElementsByTagName( 'H3' )[ 0 ]
                                              .getElementsByTagName( 'A'  )[ 0 ]
                                              .href,
                                              current ) );
            } catch( e ) { continue; }
          }
          return results;
        }
      },
    };
  }
  if( typeof ALX_NS_PH.Targets == 'undefined' ) {
    ALX_NS_PH.Targets = function ( ) {
      return this;
    };
    ALX_NS_PH.Targets.prototype = {
      'findTarget': function ( doc ) {
        var target = null;
        var result = null;
        for( var i in ALX_NS_PH.Layouts ) {
          target = ALX_NS_PH.Layouts[ i ];
          if( target.hit( doc ) ) {
            return target.collect( doc );
          }
        }
        return [ ];
      }
    };
    ALX_NS_PH.Targets = new ALX_NS_PH.Targets( );
  }
})( );


