var AmazonUWLExt = function(){
    var getMostRecentWindow = function() {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]  
                           .getService(Components.interfaces.nsIWindowMediator);  
        return wm.getMostRecentWindow("navigator:browser");
    }
    
    var runBookmarkletInDocument = function(tgtWindow) {
        var tgtDocument = tgtWindow.content.document;
        var scriptElement = tgtDocument.createElementNS("http://www.w3.org/1999/xhtml","script");
        /* I've attempted quite a few things here to do this cleaner, but aiming for perfect bookmarklet emulation here... */

        var bookmarkletSrc = "(function(){\
        var w=window,l=w.location,d=w.document,s=d.createElement('script'),e=encodeURIComponent,x='undefined',u='http://www.amazon.com/wishlist/add';\
        if(typeof s!='object')l.href=u+'/ref=cm_wlext_a2wl?u='+e(l)+'&t='+e(d.title);\
        function g(){\
        if(d.readyState&&d.readyState!='complete'){setTimeout(g,200);}else{\
        if(typeof AUWLBook==x)s.setAttribute('src',u+'.js?loc='+e(l)),d.body.appendChild(s);\
        function f(){(typeof AUWLBook==x)?setTimeout(f,200):AUWLBook.showPopover();}\
        f();\
        }\
        }\
        g();\
        })()";

        scriptElement.innerHTML = bookmarkletSrc;
        tgtDocument.body.appendChild(scriptElement);
    }
    
    this.addToWishlist = function() {
        var tgtWindow = getMostRecentWindow();
        runBookmarkletInDocument(tgtWindow);
    }
    
    this.goToWishlist = function() {
        var tgtWindow = getMostRecentWindow();
        tgtWindow.content.location = tagUrl("http://www.amazon.com/wishlist/ref=cm_wlext_wl",true);
    }
    
    this.goToAmazon = function() {
        var tgtWindow = getMostRecentWindow();
        tgtWindow.content.location = tagUrl("http://www.amazon.com/ref=cm_wlext_gw",true);
    }
    
    this.searchSelect = function(element) {
        document.getElementById("amznUWLSearchDrop").label = element.label + " ";
        document.getElementById("amznUWLSearchDrop").value = element.value;
    }

    this.searchKeyDown = function(event) {
        if(event.keyCode == event.DOM_VK_RETURN) {
            this.searchAmazon();
        }
    }
    
    var urlBase = "http://www.amazon.com/";
    var searchUrlGenerators = {
      'product' :
        function(terms) { 
            return urlBase + "s/ref=cm_wlext_s_pr?index=blended&field-keywords=" + escape(terms);
        },
      'wishlist' :
        function(terms) { 
            return urlBase + "gp/registry/search.html/ref=cm_wlext_s_wl?type=wishlist&index=us-xml-wishlist&field-name=" + escape(terms);
        },
      'reviews' :
        function(terms) { 
            return urlBase + "gp/community-content-search/results/ref=cm_wlext_s_rv?search-alias=community-reviews&query=" + escape(terms);
        },
      'listmania' :
        function(terms) { 
            return urlBase + "gp/community-content-search/results/ref=cm_wlext_s_lm?search-alias=rp-listmania&query=" + escape(terms);
        },
      'discussions' :
        function(terms) {
            return urlBase + "gp/communities/search/ref=cm_wlext_s_di?cdQuery=" + escape(terms);
        },
      'people' :
        function(terms) {
            return urlBase + "gp/pdp/search/ref=cm_wlext_s_pe?flatten=1&keywords=" + escape(terms);
        },
       'wedding' :
        function(terms) {
            return urlBase + "gp/registry/search.html/ref=cm_wlext_s_we?type=wedding&field-name=" + escape(terms);
        },
        'baby' :
         function(terms) {
             return urlBase + "gp/registry/search.html/ref=cm_wlext_s_ba?type=baby&field-name=" + escape(terms);
         }
    };
    
    var tagUrl = function(url,first) {
        var sep = "&";
        if(first) {
            sep = "?";
        }
        return url + sep + "tag=ffuwl-20";
    }
    
    this.textFieldInitialized = false;
    
    this.searchAmazon = function() {
        var tgtWindow = getMostRecentWindow();
        var searchType = document.getElementById("amznUWLSearchDrop").value;
        if(searchType === undefined) {
            searchType = 'product';
        }
        
        var searchField = document.getElementById("amznUWLsearchtext");
        var searchValue = this.textFieldInitialized ? searchField.value : "";
        tgtWindow.content.location = tagUrl(searchUrlGenerators[searchType](searchValue));
    };
    
    this.gotoDeals = function() {
        var tgtWindow = getMostRecentWindow();
        tgtWindow.content.location = tagUrl("http://www.amazon.com/gp/goldbox/ref=cm_wlext_gb",true);
        
    }
    
    this.focusText = function(element) {
        if(!this.textFieldInitialized) {
            element.style.color = "black";
            this.textFieldInitialized = true;
            element.value = "";
        }
    }
}

var amznAUWL = new AmazonUWLExt();
 

